//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using ump = unordered_map<int, int>;
const int mod = 1e9 + 7;
const int maxX =  2e6 + 1;
int n, q;
int arr[maxX];
struct nd
{
    ump his;
    int val = 0;
};
int pos[maxX];
nd seg[maxX << 1];
int posId = 0, szId = 0;

inline void add(int& num, int a)
{ num = (ll(num) + a) % mod; }

inline int gcd(int a, int b)
{ return !a || !b ? 0 : __gcd(a, b); }

ll number, freq;
void comb(int v, int le, int ri)
{
    seg[v].his.clear();
    seg[v].val = 0;
    for(auto [a, b] : seg[le].his)
        add(seg[v].his[a], b);
    for(auto [c, d] : seg[ri].his)
        add(seg[v].his[c], d);
    add(seg[v].val, seg[le].val);
    add(seg[v].val, seg[ri].val);
    for(auto [a, b] : seg[le].his)
        for(auto [c, d] : seg[ri].his)
    {
        number = gcd(a, c);
        freq = ll(b) * d % mod;
        add(seg[v].his[number], freq);
        add(seg[v].val, number * freq % mod);
    }
}

#define segTree 1, 0, maxX
void build(int v, int l, int r)
{
    if(r - l == 1)
    {
        seg[v].val = arr[l];
        seg[v].his[arr[l]] = 1;
        return;
    }
    int mid = l + (r - l >> 1),
        le = v + 1,
        ri = v + (mid - l << 1);
    build(le, l, mid);
    build(ri, mid, r);
    comb(v, le, ri);
}

int qP;
void update(int v, int l, int r)
{
    if(r - l == 1)
    {
        seg[v].val = arr[l];
        seg[v].his.clear();
        seg[v].his[arr[l]] = 1;
        return;
    }
    int mid = l + (r - l >> 1),
        le = v + 1,
        ri = v + (mid - l << 1);
    if(qP < mid)
        update(le, l, mid);
    else
        update(ri, mid, r);
    comb(v, le, ri);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    cin >>n >>q;
    for(int i = 0; i < n; i++)
    {
        cin >>arr[i];
        pos[arr[i]] = posId++;
    }
    szId = n;
    build(segTree);
    int a, b;
    cout <<seg[1].val <<"\n";
    while(q--)
    {
        cin >>a >>b;
        if(a == 1)
        {
            arr[szId++] = b;
            pos[b] = posId++;
            qP = pos[b];
        }
        else
        {
            arr[pos[b]] = 0;
            qP = pos[b];
        }
        update(segTree);
        cout <<seg[1].val <<"\n";
    }
}
