//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
#include<bits/stdc++.h>
using namespace std;

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
const int cnt = 7;
int n, q;
vvi sep[cnt];
vi pos[cnt];
vi lens, og;
const int pow10[cnt] = {1, 10, 100, 1000, 10000, 100000, 1000000};

void read()
{
    vvi a;
    cin >>n >>q;
    a.resize(n);
    og.resize(n);
    lens.resize(n, 0);
    for(int& i : og) cin >>i;
    for(int i = 0, num; i < n; i++)
    {
        a[i].reserve(cnt);
        num = og[i];
        while(num)
        {
            a[i].emplace_back(num % 10);
            num /= 10;
            lens[i]++;
        }
        lens[i]--;
    }
    for(int i = 0; i < n; i++)
    {
        sep[lens[i]].emplace_back(a[i]);
        pos[lens[i]].emplace_back(i);
    }
}

#define all(x) x.begin(), x.end()
int findIndex(int i, int id1)
{ return lower_bound(all(pos[id1]), i) - pos[id1].begin(); }

struct LDigitSegTree
{
    int id1, len, n;
    vector<deque<int>> seg;
    vector<short> lz;
    bool empty = 0;

    #define segTree 1, 0, n
    LDigitSegTree() : id1(0), len(0){}
    LDigitSegTree(int n, int id1) : n(n), id1(id1), len(id1 + 1)
    {
        if(!n)
        {
            empty = 1;
            return;
        }
        seg.assign(n << 1, deque<int>(len, 0));
        lz.assign(seg.size(), 0);
        build(segTree);
    }

    void build(int v, int l, int r)
    {
        if(r - l == 1)
        {
            for(int id2 = 0; id2 < len; id2++)
                seg[v][id2] = sep[id1][l][id2];
            return;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        build(le, l, mid);
        build(ri, mid, r);
        for(int id2 = 0; id2 < len; id2++)
            seg[v][id2] = seg[le][id2] + seg[ri][id2];
    }

    inline void rotate(deque<int>& a, int iter)
    {
        for(int i = 0; i < iter; i++)
        {
            a.emplace_back(a[0]);
            a.pop_front();
        }
    }

    inline void push(int v, int le, int ri)
    {
        rotate(seg[le], lz[v]);
        rotate(seg[ri], lz[v]);
        lz[le] = (lz[le] + lz[v]) % id1;
        lz[ri] = (lz[ri] + lz[v]) % id1;
        lz[v] = 0;
    }

    inline void comb(int v, int le, int ri)
    {
        for(int id2 = 0; id2 < len; id2++)
            seg[v][id2] = seg[le][id2] + seg[ri][id2];
    }

    int qL, qR;
    void update(int v, int l, int r)
    {
        if(qR <= l || r <= qL) return;
        if(qL <= l && r <= qR)
        {
            rotate(seg[v], 1);
            lz[v]++;
            lz[v] %= len;
            return;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        if(lz[v])
            push(v, le, ri);
        update(le, l, mid);
        update(ri, mid, r);
        comb(v, le, ri);
    }
    void update(int l, int r)
    {
        if(l == r || empty) return;
        qL = l, qR = r;
        update(segTree);
    }

    ll query(int v, int l, int r)
    {
        if(qR <= l || r <= qL) return 0LL;
        if(qL <= l && r <= qR)
        {
            ll sum = 0;
            for(int id2 = 0; id2 < len; id2++)
                sum += seg[v][id2] * pow10[id2];
            return sum;
        }
        int mid = l + (r - l >> 1),
            le = v + 1,
            ri = v + (mid - l << 1);
        if(lz[v])
            push(v, le, ri);
        ll d = query(le, l, mid) +
               query(ri, mid, r);
        comb(v, le, ri);
        return d;
    }
    ll query(int l, int r)
    {
        qL = l, qR = r;
        return l == r || empty ? 0 : query(segTree);
    }
};
LDigitSegTree digSegTrees[cnt];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);

    read();
    for(int id1 = 0; id1 < cnt; id1++)
        digSegTrees[id1] = LDigitSegTree(sep[id1].size(), id1);

    int qL, qR;
    char c;
    while(q--)
    {
        cin >>c >>qL >>qR;
        qL--;

        if(c == '1')
        {
            for(int id1 = 0; id1 < cnt; id1++)
                //(cout <<id1 <<": " <<qL <<qR <<" -> " <<findIndex(qL, id1) <<" " <<findIndex(qR, id1) <<endl),
                digSegTrees[id1].update(findIndex(qL, id1), findIndex(qR, id1));
        }
        else
        {
            ll sum = 0;
            for(int id1 = 0; id1 < cnt; id1++)
                //(cout <<id1 <<": " <<qL <<qR <<" -> " <<findIndex(qL, id1) <<" " <<findIndex(qR, id1) <<endl),
                sum += digSegTrees[id1].query(findIndex(qL, id1), findIndex(qR, id1));//,
                //(cout <<"After " <<id1 <<": " <<sum <<endl);
            cout <<sum <<"\n";// <<endl;
        }
    }
}
