#include <bits/stdc++.h>
using namespace std;
const long long MAX_N=1000010;
long long n, tr[4*MAX_N], q, mass[MAX_N];

void tree(long long n, long long l, long long r) {
    if(l==r) {
        tr[n]=mass[l];
    }
    else {
        long long mid=(l+r)/2;
        tree(2*n,l,mid);
        tree(2*n+1,mid+1,r);
        tr[n]=tr[2*n]+tr[2*n+1];
    }
}

void update (long long n, long long vl, long long vr, long long l, long long r) {
    if(vl>r || vr<l) {
        return;
    }
    else if(vl==vr) {
        //cout << mass[vl] << "\n";
        if(mass[vl]/100==0) {
            tr[n]=tr[n]+9*((tr[n]%10)-(tr[n]/10));
        }
        else {
            tr[n]=tr[n]+9*(11*(tr[n]%10)-10*(tr[n]/100)-(tr[n]/10)%10);
        }
        //cout << tr[n] << "\n";
    }
    else {
        long long mid=(vl+vr)/2;
        update(2*n,vl,mid,l,r);
        update(2*n+1,mid+1,vr,l,r);
        tr[n]=tr[2*n]+tr[2*n+1];
    }


}

long long suma(long long n,long long vl,long long vr,long long l,long long r) {
    if(vl>r || vr<l) {
        return 0;
    }
    if(vl==vr) {
        return tr[n];
    }

    long long mid=(vl+vr)/2;
    return suma(2*n,vl,mid,l,r)+suma(2*n+1,mid+1,vr,l,r);
}


signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q;
    for(long long i=1; i<=n; i++) {
        cin >> mass[i];
    }
    tree(1,1,n);
    for(long long i=1; i<=q; i++) {
        long long vid,l,r;
        cin >> vid >> l >> r;
        if(vid==1) {
            update(1,1,n,l,r);
        }
        else {
            cout << suma(1,1,n,l,r) << "\n";
        }
    }
    return 0;
}