#include <iostream>
#include <vector>
#include <numeric>
#include <math.h>

using namespace std;

int n,Q;
vector<int> gcds;
vector<int> numbers;
int SUM=0;
const int mod=1000000007;

void AddToGDCS(int x)
{
    //cout<<"ADD"<<endl;
	gcds.push_back(x);
	numbers.push_back(x);
	SUM+=x;
    if(SUM>=mod)SUM%mod;
	int right=gcds.size()-1;
	for(int i=0;i<right;i++)
    {
		gcds.push_back(gcd(x,gcds[i]));
        SUM+=gcd(x,gcds[i]);
        if(SUM>=mod)SUM%mod;
    }
}

void RemoveFromGDCS(int x)
{
    //cout<<"Remove"<<endl;
    vector<int> temp;
    int index=0;
    for(index=0;index<numbers.size()&&numbers[index]!=x;index++);
    numbers.erase(numbers.begin()+index);
    int power=pow(2,index);
    int jump=power-1;
    bool add=true;
    //cout<<power<<"  "<<jump<<"  "<<add<<endl;
    SUM=0;
    for(int i=0;i<gcds.size();i++)
    {
        if(jump==0)
        {
            add=!add;
            jump=power;
        }
        if(add)
        {
            jump--;
            SUM+=gcds[i];
            if(SUM>=mod)SUM%mod;
            temp.push_back(gcds[i]);
            continue;
        }
        else jump--;
    }
/*    for(int i=0;i<temp.size();i++)
        cout<<temp[i]<<" ";
 */
    gcds=temp;


}

int main()
{
	int x,a,b;
	cin>>n>>Q;
	for(int i=0;i<n;i++)
	{
		scanf("%d",&x);
		AddToGDCS(x);
	}
	cout<<SUM<<endl;
	for(int i=0;i<Q;i++)
    {
		scanf("%d%d",&a,&b);
        if(a==1)AddToGDCS(b);
        else RemoveFromGDCS(b);
        cout<<SUM<<endl;
    }
	/*for(int i=0;i<numbers.size();i++)
        cout<<numbers[i]<<" ";*/
}
/*
4 3
4 8 16 39
2 39
1 16
1 39
*/
