#include<bits/stdc++.h>
using namespace std;
const int MAX_N = 3002;
const int MOD = 1e9+7;
int table[MAX_N];
int active = 0;
int fast_pow(int num, int st)
{
    if(st == 0) return 1;
    int half = fast_pow(num, st/2);
    if(st&1) return ((((half*half)%MOD)*num)%MOD);
    return (half*half)%MOD;
}
int calc_table(int br)
{
    if(br == 0) return 0;
    int all = fast_pow(2,br)-1;
    if(all < 0) all += MOD;
    int res = 0;
    for(int i=1; i<=3000; i++)
    {
        if(table[i])
        {
            int sub_size = 0;
            for(int j=i*2; j<=3000; j+=i)
            {
                sub_size += table[j];
            }
            int tmp = fast_pow(2,sub_size);
            res+=((i*tmp)%MOD);
            res%=MOD;
            all-=tmp;
            if(all < 0) all+=MOD;
        }
    }
    res += all;
    return res;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,q,c;
    set<int> s;
    cin>>n>>q;
    active = n;
    for(int i=0; i<n; i++)
    {
        cin>>c;
        table[c] = 1;
    }
    cout<<calc_table(active)<<endl;
    int type0, num0;
    for(int i=0; i<q; i++)
    {
        cin>>type0>>num0;
        if(type0 == 1)
        {
            table[num0] = 1;
            active++;
        }
        else
        {
            table[num0] = 0;
            active--;
        }
        cout<<calc_table(active)<<endl;
    }
}
