#include<bits/stdc++.h>
using namespace std;
const int MAX_N = 1e6+2;
int tree[4*MAX_N];
int a[MAX_N];
int conv(int num1)
{
//    cout<<a[idx]<<endl;
    int num = num1/10;
    int dig = num1%10;
    int st = 1;
    while(num > 0)
    {
        num/=10;
        st*=10;
    }
    num1 = num1/10 + (st*dig);
    return num1;
}
void build(int node, int tl, int tr)
{
    if(tl == tr)
    {
        tree[node] = a[tl];
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    tree[node] = tree[node*2]+tree[node*2+1];
}
int query(int node, int tl, int tr, int l, int r)
{
    if(tl > r || tr < l) return 0;
    if(tl >= l && tr <= r) return tree[node];
    int mid = (tl+tr)/2;
    return (query(node*2, tl, mid, l, r)+query(node*2+1, mid+1, tr, l, r));
}
void update(int node, int tl, int tr, int l, int r)
{
    if(tl > r || tr < l) return;
    if(tl == tr)
    {
//        cout<<tree[node]<<" ";
        tree[node] = conv(tree[node]);
//        cout<<tree[node]<<endl;
        return;
    }
    int mid = (tl+tr)/2;
    update(node*2, tl, mid, l, r);
    update(node*2+1, mid+1, tr, l, r);
    tree[node] = tree[node*2] + tree[node*2+1];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,q;
    cin>>n>>q;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    build(1,1,n);
    int type0, l0, r0;
    for(int it=0; it<q; it++)
    {
        cin>>type0>>l0>>r0;
        if(type0 == 1)
        {
            update(1,1,n,l0,r0);
        }
        if(type0 == 2)
        {
            cout<<query(1,1,n,l0,r0)<<endl;
        }
    }
}
/**
3 5
15 35 112
1 1 1
1 2 2
1 3 3
1 3 3
2 1 3

*/
