#include<bits/stdc++.h>
#define ll long long
using namespace std;
const ll MAX_N = 1e6+2;
ll tree[4*MAX_N];
ll a[MAX_N];
ll conv(ll num1)
{
    ll num = num1/10;
    ll dig = num1%10;
    ll st = 1;
    while(num > 0)
    {
        num/=10;
        st*=10;
    }
    num1 = num1/10 + (st*dig);
    return num1;
}
void build(ll node, ll tl, ll tr)
{
    if(tl == tr)
    {
        tree[node] = a[tl];
        return;
    }
    ll mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    tree[node] = tree[node*2]+tree[node*2+1];
}
ll query(ll node, ll tl, ll tr, ll l, ll r)
{
    if(tl > r || tr < l) return 0;
    if(tl >= l && tr <= r) return tree[node];
    ll mid = (tl+tr)/2;
    return (query(node*2, tl, mid, l, r)+query(node*2+1, mid+1, tr, l, r));
}
void update(ll node, ll tl, ll tr, ll l, ll r)
{
    if(tl > r || tr < l) return;
    if(tl == tr)
    {
        cout<<tree[node]<<" ";
        tree[node] = conv(tree[node]);
        cout<<tree[node]<<endl;
        return;
    }
    ll mid = (tl+tr)/2;
    update(node*2, tl, mid, l, r);
    update(node*2+1, mid+1, tr, l, r);
    tree[node] = tree[node*2] + tree[node*2+1];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n,q;
    cin>>n>>q;
    for(ll i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    build(1,1,n);
    ll type0, l0, r0;
    for(ll it=0; it<q; it++)
    {
        cin>>type0>>l0>>r0;
        if(type0 == 1)
        {
            update(1,1,n,l0,r0);
        }
        if(type0 == 2)
        {
            cout<<query(1,1,n,l0,r0)<<endl;
        }
    }
}
/**
4 9
15 35 112 12345
1 4 4
1 4 4
1 4 4
1 4 4
1 4 4
1 4 4
1 4 4
2 1 3
2 1 4

*/
