#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+5, maxa = 2e6+6, mod = 1e9+7;
int n, q;
long long d1 [maxa], d2 [maxa], dBruteforce [maxa], d2Bruteforce [maxa], sum, sumBruteforce;

bool notPrime [maxa];
vector <int> primes;
void findPrimes (){
    for (int i = 2; i < maxa; i ++){
        if (notPrime [i]) continue;
        primes.push_back (i);
        for (int j = i + i; j < maxa; j += i) notPrime [j] = 1;
    }
}

vector <pair <int, int> > divs, divs1;
void calcDivs (bool rm){
    int d = 1;
    for (auto p : divs1){
        for (int i = 0; i < p.second; i ++) d *= p.first;
    }
    if (!rm){
        d1 [d] = (d1 [d] + d2 [d]) % mod;
        sum += (long long) d * d2 [d];
        sum %= mod;
    }
    else{
        d2 [d] --;
        if (d2 [d] % 2) d2 [d] += mod;
        d2 [d] /= 2;
        d1 [d] = (d1 [d] + mod - d2 [d]) % mod;
        sum += mod - (long long) d * d2 [d] % mod;
        sum %= mod;
    }
    for (auto p : divs1){
        int dd = d / p.first;
        if (!rm){
            d1 [dd] = (d1 [dd] + mod - d2 [d]) % mod;
            sum += mod - (long long) dd * d2 [d] % mod;
            sum %= mod;
        }
        else{
            d1 [dd] = (d1 [dd] + d2 [d]) % mod;
            sum += (long long) dd * d2 [d];
            sum %= mod;
        }
    }
    if (!rm) d2 [d] = (d2 [d] * 2 + 1) % mod;
}
void cycleDivs (int pos, bool rm){
    if (pos == divs.size ()){
        calcDivs (rm);
        return;
    }
    cycleDivs (pos + 1, rm);
    divs1.push_back ({divs [pos].first, 1});
    int x = divs [pos].second;
    while (x --){
        cycleDivs (pos + 1, rm);
        divs1.back ().second ++;
    }
    divs1.pop_back ();
}

void addNumber (int a, bool rm){
    if (!rm){
        d1 [a] ++;
        d1 [a] %= mod;
        sum += a;
        sum %= mod;
    }
    else{
        d1 [a] += mod - 1;
        d1 [a] %= mod;
        sum += mod - a;
        sum %= mod;
    }
    divs.clear ();
    divs1.clear ();
    for (int i : primes){
        if (a % i > 0) continue;
        divs.push_back ({i, 0});
        while (a % i == 0){
            divs.back ().second ++;
            a /= i;
        }
        if (a > 1 && !notPrime [a]){
            divs.push_back ({a, 1});
            a = 1;
        }
        if (a == 1) break;
    }
    cycleDivs (0, rm);
}

set <int> s;
void addNumberBruteforce (int a){
    for (int i : s){
        int gcd = __gcd (a, i);
        sumBruteforce += dBruteforce [i] * gcd;
        sumBruteforce %= mod;
        dBruteforce [gcd] += dBruteforce [i];
        dBruteforce [gcd] %= mod;
        s.insert (gcd);
    }
    dBruteforce [a] ++;
    dBruteforce [a] %= mod;
    sumBruteforce += a;
    sumBruteforce %= mod;
    s.insert (a);
}
void removeNumberBruteforce (int a){
    dBruteforce [a] += mod - 1;
    dBruteforce [a] %= mod;
    sumBruteforce += mod - a;
    sumBruteforce %= mod;
    auto it = s.end ();
    while (it != s.begin ()){
        it --;
        int i = *it;
        int gcd = __gcd (a, i);
        if (gcd == i){
            if (dBruteforce [i] % 2) dBruteforce [i] += mod;
            dBruteforce [i] /= 2;
            sumBruteforce += mod - dBruteforce [i] * gcd % mod;
            sumBruteforce %= mod;
        }
        else{
            dBruteforce [gcd] += mod - dBruteforce [i];
            dBruteforce [gcd] %= mod;
            sumBruteforce += mod - dBruteforce [i] * gcd % mod;
            sumBruteforce %= mod;
        }
    }
}

//mt19937 mt (455612);

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    //findPrimes ();

    cin >> n >> q;
    for (int i = 0; i < n; i ++){
        int a;
        cin >> a;
        addNumberBruteforce (a);
    }
    cout << sumBruteforce << '\n';
    while (q --){
        int t, a;
        cin >> t >> a;
        if (t == 1){
            addNumberBruteforce (a);
        }
        else{
            removeNumberBruteforce (a);
        }
        cout << sumBruteforce << '\n';
        /*for (int i = 0; i < maxa; i ++) d2Bruteforce [i] = 0;
        for (int i = 0; i < maxa; i ++){
            for (int j = 1; j <= i; j ++){
                if (i % j == 0) d2Bruteforce [j] += dBruteforce [i];
            }
        }
        if (sum == sumBruteforce){
            cout << "ok " << sum << '\n';
            for (int i = 1; i <= 50; i ++) cout << d1 [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << dBruteforce [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << d2 [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << d2Bruteforce [i] << ' ';
            cout << '\n';
        }
        else{
            cout << "not ok\n" << sum << ' ' << sumBruteforce << '\n';
            for (int i = 1; i <= 50; i ++) cout << d1 [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << dBruteforce [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << d2 [i] << ' ';
            cout << '\n';
            for (int i = 1; i <= 50; i ++) cout << d2Bruteforce [i] << ' ';
            cout << '\n';
            break;
        }*/
    }

}
