#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+5, maxa = 2e6+6, mod = 1e9+7;
int n, a [maxn], q;
int d [maxa];
long long cnt [maxa], sum;
long long dBruteforce [maxa], sumBruteforce;

long long fastPow (int x, int s){
    if (s == 0) return 1;
    long long p = fastPow (x, s >> 1);
    if (s & 1) return p * p % mod * x % mod;
    else return p * p % mod;
}

set <int> s;
void addNumberBruteforce (int a){
    for (int i : s){
        int gcd = __gcd (a, i);
        sumBruteforce += dBruteforce [i] * gcd;
        sumBruteforce %= mod;
        dBruteforce [gcd] += dBruteforce [i];
        dBruteforce [gcd] %= mod;
        s.insert (gcd);
    }
    dBruteforce [a] ++;
    dBruteforce [a] %= mod;
    sumBruteforce += a;
    sumBruteforce %= mod;
    s.insert (a);
}
void removeNumberBruteforce (int a){
    dBruteforce [a] += mod - 1;
    dBruteforce [a] %= mod;
    sumBruteforce += mod - a;
    sumBruteforce %= mod;
    auto it = s.end ();
    while (it != s.begin ()){
        it --;
        int i = *it;
        int gcd = __gcd (a, i);
        if (gcd == i){
            if (dBruteforce [i] % 2) dBruteforce [i] += mod;
            dBruteforce [i] /= 2;
            sumBruteforce += mod - dBruteforce [i] * gcd % mod;
            sumBruteforce %= mod;
        }
        else{
            dBruteforce [gcd] += mod - dBruteforce [i];
            dBruteforce [gcd] %= mod;
            sumBruteforce += mod - dBruteforce [i] * gcd % mod;
            sumBruteforce %= mod;
        }
    }
}

mt19937 mt (42);

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> q;
    for (int i = 0; i < n; i ++){
        cin >> a [i];
        for (int j = 1; j * j <= a [i]; j ++){
            if (a [i] % j == 0){
                d [j] ++;
                if (j * j != a [i]) d [a [i] / j] ++;
            }
        }
    }
    for (int i = maxa - 1; i >= 1; i --){
        cnt [i] += fastPow (2, d [i]) - 1;
        if (cnt [i] >= mod) cnt [i] -= mod;
        if (cnt [i] == 0) continue;
        sum += cnt [i] * i;
        sum %= mod;
        cnt [1] += mod - cnt [i];
        if (cnt [1] >= mod) cnt [1] -= mod;
        for (int j = 2; j * j <= i; j ++){
            if (i % j == 0){
                cnt [j] += mod - cnt [i];
                if (cnt [j] >= mod) cnt [j] -= mod;
                if (j * j != i){
                    cnt [i / j] += mod - cnt [i];
                    if (cnt [i / j] >= mod) cnt [i / j] -= mod;
                }
            }
        }
    }
    cout << sum << '\n';

}

