#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e6 + 3;

int n, q;
int a[maxn];

int tr[maxn * 4][6][6], lazy[maxn * 4][6];
void merge(int v, int idx) {
    for (int i = 0; i <= idx; i++)
        tr[v][idx][i] = tr[v * 2][idx][i] + tr[v * 2 + 1][idx][i];
}

void push(int v, int idx, int l, int r) {
    int nxt[6];
    for (int i = 0; i <= idx; i++) {
        int j = (i - lazy[v][idx] % (idx + 1) + idx + 1) % (idx + 1);
        nxt[j] = tr[v][idx][i];
    }

    for (int i = 0; i <= idx; i++)
        tr[v][idx][i] = nxt[i];

    if (l != r)
        lazy[v * 2][idx] += lazy[v][idx], lazy[v * 2 + 1][idx] += lazy[v][idx];

    lazy[v][idx] = 0;
}

int cnt_dig(int num) {
    int ans = 0;
    while (num) {
        ans++;
        num /= 10;
    }

    return ans;
}

void build(int v, int l, int r) {
    if (l == r) {
        int idx = cnt_dig(a[l]) - 1, pos = 0;
        while (a[l]) {
            tr[v][idx][pos] += a[l] % 10;
            pos++;
            a[l] /= 10;
        }

        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    for (int i = 0; i < 6; i++)
        merge(v, i);
}

void update(int v, int l, int r, int ll, int rr) {
    for (int i = 0; i < 6; i++)
        push(v, i, l, r);

    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr) {
       // cout << l << "wtf" << r << endl;
        for (int i = 0; i < 6; i++) {
            lazy[v][i]++;
            push(v, i, l, r);
        }

        return;
    }

    int mid = (l + r) / 2;
    update(v * 2, l, mid, ll, rr);
    update(v * 2 + 1, mid + 1, r, ll, rr);

    for (int i = 0; i < 6; i++)
    merge(v, i);
}

int ans[6];
void get(int v, int l, int r, int ll, int rr) {
    for (int i = 0; i < 6; i++)
    push(v, i, l, r);

    if (l > rr || r < ll)
        return;

    if (l >= ll && r <= rr) {
        for (int i = 0; i < 6; i++)
        for (int j = 0; j <= i; j++)
        ans[j] += tr[v][i][j];

        return;
    }

    int mid = (l + r) / 2;
    get(v * 2, l, mid, ll, rr);
    get(v * 2 + 1, mid + 1, r, ll, rr);
}

void read() {
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> a[i];
}

void solve() {
    build(1, 1, n);
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) {
            update(1, 1, n, l, r);
        }

        else {
            for (int i = 0; i < 6; i++)
                ans[i] = 0;

            get(1, 1, n, l, r);
            long long sum = 0, st = 1;
            for (int i = 0; i < 6; i++) {
                sum += st * (long long)ans[i];
                st *= 10;
            }

            cout << sum << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3 3
15 35 112
2 1 2
1 2 3
2 1 3
*/
