#include<iostream>
using namespace std;

struct num{
    int l;
    int d[6];
};

num nums[2000000];

struct node{
    int val[2];
    bool rot=false;
};

node tree[4000000];

void updateNode(int l, int r, int i){
    tree[i].rot=false;
    swap(tree[i].val[0], tree[i].val[1]);
    if(l!=r){
        tree[i*2].rot=!tree[i*2].rot;
        tree[i*2+1].rot=!tree[i*2+1].rot;
    }
}

void updateSum(int l, int r, int i){
    tree[i].val[0]=tree[i*2].val[0]+tree[i*2+1].val[0];
    tree[i].val[1]=tree[i*2].val[1]+tree[i*2+1].val[1];
}

void bld(int l, int r, int i){
    if(l==r){
        tree[i].val[0]=nums[l].d[0];
        tree[i].val[1]=nums[l].d[1];
        return;
    }
    int m=(l+r)/2;
    bld(l, m, i*2);
    bld(m+1, r, i*2+1);
    updateSum(l, r, i);
}

void upd(int l, int r, int i, int ql, int qr){
    if(tree[i].rot){
        updateNode(l, r, i);
    }
    if(l>=ql && r<=qr){
        updateNode(l, r, i);
        return;
    }
    if(r<ql || l>qr){
        return;
    }
    int m=(l+r)/2;
    upd(l, m, i*2, ql, qr);
    upd(m+1, r, i*2+1, ql, qr);
    updateSum(l, r, i);
}

int query(int l, int r, int i, int ql, int qr){
    if(tree[i].rot){
        updateNode(l, r, i);
    }
    if(l>=ql && r<=qr){
        return tree[i].val[0]+tree[i].val[1]*10;
    }
    if(r<ql || l>qr){
        return 0;
    }
    int m=(l+r)/2;
    int sum=0;
    sum+=query(l, m, i*2, ql, qr);
    sum+=query(m+1, r, i*2+1, ql, qr);
    updateSum(l, r, i);
    return sum;
}
int main(){
    int n,q;
    cin>>n>>q;
    for(int i=0;i<n;i++){
        int a;
        cin>>a;
        while(a>0){
            nums[i].d[nums[i].l]=a%10;
            a/=10;
            nums[i].l++;
        }
    }

    bld(0, n-1, 1);

    for(int i=0;i<n*2;i++){

    }

    for(int i=0;i<q;i++){
        int t, l, r;
        cin>>t>>l>>r;
        l--;
        r--;
        if(t==1){
            upd(0, n-1, 1, l, r);
        }else{
            cout<<query(0, n-1, 1, l, r)<<endl;
        }
    }

    return 0;
}
