#include <bits/stdc++.h>
using namespace std;
int n, q;
long long rot[1000000], a[1000005], segmentTree[2000005], taken[1000000];
long long createSegmentTree(int pos, int down, int high){
    if(down==high){
        segmentTree[pos]=a[down];
        return segmentTree[pos];
    }
    int mid=(down+high)/2;
    segmentTree[pos]=createSegmentTree(2*pos+1, down, mid)+createSegmentTree(2*pos+2, mid+1, high);
    return segmentTree[pos];
}
long long rotateTree(int pos, int down, int high, int l, int r){
    if(down==high){
        segmentTree[pos]=rot[segmentTree[pos]];
        return segmentTree[pos];
    }
    int mid=(down+high)/2;
    if(l>mid){
        segmentTree[pos]=segmentTree[2*pos+1]+rotateTree(2*pos+2, mid+1, high, l, r);
        return segmentTree[pos];
    }
    if(r<=mid){
        segmentTree[pos]=segmentTree[2*pos+2]+rotateTree(2*pos+1, down, mid, l, r);
        return segmentTree[pos];
    }
    segmentTree[pos]=rotateTree(2*pos+2, mid+1, high, l, r)+rotateTree(2*pos+1, down, mid, l, r);
    return segmentTree[pos];
}
long long searchTree(int pos, int down, int high, int l, int r){
    if(down==high){
        return segmentTree[pos];
    }
    int mid=(down+high)/2;
    if(l>mid){
        return searchTree(2*pos+2, mid+1, high, l, r);
    }
    if(r<=mid){
        return searchTree(2*pos+1, down, mid, l, r);
    }
    return searchTree(2*pos+2, mid+1, high, l, r)+searchTree(2*pos+1, down, mid, l, r);
}
void printTree(){
    cout<<"\n";
    for(int i=0;i<2*n-1;i++){
        cout<<segmentTree[i]<<" ";
    }
    cout<<"\n";
}
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
for(int i=1;i<1000000;i++){
    int j=i, rem=1;
    while(true){
        if(j/10==0){
            break;
        }
        rem=rem*10;
        j=j/10;
    }
    rot[i]=(i%10)*rem+i/10;;
}
cin>>n>>q;
for(int i=0;i<n;i++){
    cin>>a[i];
}
createSegmentTree(0, 0, n-1);
for(int j=0;j<q;j++){
    int t, l, r;
    cin>>t>>l>>r;
    l--;
    r--;
    if(t==1){
        rotateTree(0, 0, n-1, l, r);
        //printTree();
    }else{
        cout<<searchTree(0, 0, n-1, l, r)<<"\n";
        //printTree();
    }
}
return 0;
}

