#include <bits/stdc++.h>
using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL

#define endl "\n"
#define out(x) "[" << #x << "=" << x << "]"

template<class T, class T2>
ostream& operator <<(ostream &out, const pair<T, T2> &x) {
    return out << x.first << " " << x.second;
}

template<class T>
ostream& operator <<(ostream &out, const vector<T> &x) {
    for(const auto &it : x) {
        out << it << " ";
    }
    return out;
}

struct debug {
    debug() { cerr << "->"; }
    ~debug() { cerr << endl; }

    template<class T>
    debug &operator <<(const T &x) {
        cerr << x << " ";
        return *this;
    }
};
#define dbg debug()

template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }

typedef long long ll;
const ll mod = 1e9 + 7;
///~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 20;
vector<ll> arr;
ll n, q;

ll gcd(ll a, ll b) {
    if(a * b == 0) {return a + b;}
    return __gcd(a, b);
}

ll solve() {
    ll ans = 0;
    for(ll mask = 1; mask < (1 << arr.size()); mask ++) {
        ll gd = 0;
        for(ll i = 0; i < arr.size(); i ++) {
            if(mask & (1 << i)) {
                gd = gcd(arr[i], gd);
            }
        }
        ans += gd;
        ans %= mod;
    }
    return ans;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    arr.resize(n);
    for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }

    cout << solve() << endl;

    while(q --) {
        ll t;
        cin >> t;
        if(t == 1) {
            ll x;
            cin >> x;
            arr.push_back(x);
        } else {
            ll x;
            cin >> x;
            for(ll i = 0; i < arr.size(); i ++) {
                if(arr[i] == x) {
                    swap(arr[i], arr[arr.size() - 1]);
                    arr.pop_back();
                    break;
                }
            }
        }
        cout << solve() << endl;
    }


    return 0;
}
