#include<iostream>
#include<vector>
#include<set>
using namespace std;

int broiChisla;
int broiZaqvki;

set<long long> chisla;

vector<long long> tekushtiChisla;

long long gcd(long long a, long long b){

    while(b != 0){
        long long p = b;
        b = a%b;
        a = p;
    }

    return a;
}

long long suma = 0;

void smetniSegaSuma(){
    if(tekushtiChisla.size() == 0){
        return ;
    }
    if(tekushtiChisla.size() == 1){
        suma += tekushtiChisla[0];
        return ;
    }

    int tukaNod = gcd(tekushtiChisla[0], tekushtiChisla[1]);

    for(int i = 2; i < (int)tekushtiChisla.size(); i++){
        tukaNod = gcd(tukaNod, tekushtiChisla[i]);
    }

    suma += tukaNod;

}

void nameriSumata(set<long long>::iterator segashno){
    if(segashno == chisla.end()){
        smetniSegaSuma();
        return ;
    }

    segashno++;
    nameriSumata(segashno);
    segashno--;

    tekushtiChisla.push_back(*segashno);
    segashno++;
    nameriSumata(segashno);
    segashno--;
    tekushtiChisla.pop_back();
}

vector<long long> otgovori;

int main(){

    cin>>broiChisla>>broiZaqvki;

    for(int i = 0; i < broiChisla; i++){
        int tukaChi;
        cin>>tukaChi;

        chisla.insert(tukaChi);
    }

    nameriSumata(chisla.begin());

    otgovori.push_back(suma);

    for(int i = 0; i < broiZaqvki; i++){
        int tip;
        int chislo;

        cin>>tip>>chislo;

        if(tip == 1){
            chisla.insert(chislo);
        }else{
            chisla.erase(chislo);
        }

        suma = 0;
        nameriSumata(chisla.begin());

        otgovori.push_back(suma);
    }

    for(int i = 0; i < (int)otgovori.size(); i++){
        cout<<otgovori[i]<<endl;
    }

    return 0;
}
