#include<iostream>
#include<cmath>
#define ll long long
#define endl "\n"
using namespace std;

const ll maxn=1e6+2;
ll n,q,a[maxn],brcifri[maxn],tree[maxn];

ll constr(ll curr){
    if(curr>=n){
        tree[curr]=a[curr-n];
        return tree[curr];
    }
    tree[curr]=constr(curr*2)+constr(curr*2+1);
    return tree[curr];
}

void update(ll curr, ll val){
    tree[curr]+=val;
    if(curr==1){
        return;
    }
    update(curr/2,val);
}

ll sum(ll curr, ll vl, ll vr, ll l, ll r){
    if(vl>=vr){
        if(vl>=l and vl<=r){
            return  tree[curr];
        }else{
            return 0;
        }
    }
    if(vl>=l and vr<=r){
        return tree[curr];
    }
    if(vl>r or vr<l){
        return 0;
    }
    if(curr>1000){
        return 0;
    }
    ll m=(vl+vr)/2;
    return sum(curr*2,vl,m,l,r)+sum(curr*2+1,m+1,vr,l,r);
}


int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    ll t,from,to;
    cin >> n >> q;
    for(ll i=0;i<n;i++){
        cin >> a[i];
        ll copya=a[i];
        while(copya>0){
            brcifri[i]++;
            copya/=10;
        }
    }
    constr(1);
    for(ll i=0;i<q;i++){
        cin >> t >> from >> to;
        from--;
        to--;
        if(t==1){
            if(from==to){
                ll x=a[from];
                a[from]=x/10+(x%10)*(pow(10,(brcifri[from]-1)));
                update(from+n,a[from]-x);
            }else{
                for(ll j=from;j<=to;j++){
                    ll x=a[j];
                    a[j]=x/10+(x%10)*(pow(10,(brcifri[j]-1)));

                }
            }
        }else{
            /*ll sum=0;
            for(ll j=from;j<=to;j++){
                sum+=tree[j+n];
            }*/
            //x=pow(2,log2(n))
            cout << sum(1,n,2*n-1,from+n,to+n) << endl;
        }
    }
return 0;
}
