#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const long long N = 2e6 + 10, mod = 1e9 + 7;
long long n, q;
long long a[N], c[N], p[N], inv[N], has[N];
set<long long> s;

long long powing(long long x, long long y)
{
    long long res = 1;
    while(y)
    {
        if(y % 2) res = (res * x) % mod;
        y /= 2;
        x = (x * x) % mod;
        //res = (res * x) % mod;
    }
    return res;
}

void make_c()
{
    p[0] = inv[0] = 1;
    for(long long i = 1; i <= n + q; ++i)
    {
        p[i] = (p[i - 1] * i) % mod;
        inv[i] = (inv[i - 1] * powing(i, mod - 2)) % mod;
    }
    //for(int i = 1; i <= n; ++i) cout << p[i] << " ";
    //cout << endl;
    //for(int i = 1; i <= n; ++i) cout << inv[i] << " ";
    //cout << endl;
}

long long rCk(long long r, long long k)
{
    //cout << (((p[r] * inv[r - k]) % mod) * inv[k]) % mod << endl;
    return (((p[r] * inv[r - k]) % mod) * inv[k]) % mod;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long t, x, max_el = 0, ans = 0;
    cin >> n >> q;
    for(long long i = 1; i <= n; ++i) cin >> a[i], has[a[i]] = 1, max_el = max(max_el, a[i]);//, s.insert(a[i]);
    //cout << powing(3, 6) << endl;
    make_c();
    //for(int i = 0)
    //cout << max_el << endl;
    ans = 0;
    //cin >> t >> x;
    //if(t == 1) has[x] = 1;
    //else has[x] = 0;
    for(long long i = max_el; i >= 1; --i)
    {
        //cout << "phase: " << i << endl;
        long long sum = 0, cnt = 0;
        for(long long j = i; j <= max_el; j += i) cnt += has[j];
        //cout << cnt << endl;
        for(long long j = 1; j <= cnt; ++j) sum = (sum + rCk(cnt, j)) % mod;
        //cout << sum << endl;
        for(long long j = i; j <= max_el; j += i) sum = (sum - c[j] + mod) % mod;
        c[i] = sum;
        ans = (ans + (i * sum) % mod) % mod;
    }
    cout << ans << endl;
    while(q--)
    {
        ans = 0;
        cin >> t >> x;
        if(t == 1) has[x] = 1, max_el = max(max_el, x);
        else has[x] = 0;
        //max_el = *((s.end())--);
        //cout << max_el << endl;
        memset(c, 0, sizeof(c));
        for(long long i = max_el; i >= 1; --i)
        {
            //cout << "phase: " << i << endl;
            long long sum = 0, cnt = 0;
            for(long long j = i; j <= max_el; j += i) cnt += has[j];
            //cout << cnt << endl;
            for(long long j = 1; j <= cnt; ++j) sum = (sum + rCk(cnt, j)) % mod;
            //cout << sum << endl;
            for(long long j = i; j <= max_el; j += i) sum = (sum - c[j] + mod) % mod;
            c[i] = sum;
            ans = (ans + (i * sum) % mod) % mod;
        }
        cout << ans << endl;
    }

    //for(int i = 1; i <= max_el; ++i) cout << c[i] << " " ;

    return 0;
}
/*
5 0
2 4 6 8 12
*/
