#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn = 1000001;
long long n,q;
long long a[maxn];
long long tree[maxn*4];
long long pw[128];
void make_tree( long long i, long long l, long long r )
{
    if( l == r )
    {
        tree[i] = a[l];
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i] = tree[i*2] + tree[i*2+1];
    return;
}
long long get_num( long long x )
{
    if( x < 10 ) return 1;
    long long cnt = 0;
    while( x != 0 )
    {
        cnt += 1;
        x /= 10;
    }
    return cnt;
}
long long rot_x( long long x, long long cnt )
{
    long long cnt_num = get_num(x);
    long long ans = x;
    while( cnt != 0 )
    {
        cnt -= 1;
        long long t1 = ans % 10;
        long long t2 = ans / 10;
        t1 *= pw[cnt_num];
        t1 += t2;
        ans = t1;
    }
    return ans;
}
void update( long long i, long long l, long long r, long long pos )
{
    if( l == r )
    {
        tree[i] = rot_x( tree[i] , 1 );
        return;
    }
    long long m = ( l + r ) / 2;
    if( pos <= m ) update(i*2,l,m,pos);
    else update(i*2+1,m+1,r,pos);
    tree[i] = tree[i*2] + tree[i*2+1];
    return;
}
long long query(long long i, long long l, long long r, long long ql, long long qr )
{
    if( l == ql && r == qr )
    {
        return tree[i];
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else
    {
        return ( query(i*2,l,m,ql,m) + query(i*2+1,m+1,r,m+1,qr) );
    }
}
void read()
{
    cin >> n >> q;
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> a[i];
    }
    make_tree(1,1,n);
    for( long long i = 1; i <= q; i ++ )
    {
        long long t,l,r;
        cin >> t >> l >> r;
        if( t == 1 )
        {
            for( int j = l; j <= r; j ++ )
                update(1,1,n,j);
        }
        else
        {
            cout << query(1,1,n,l,r) << endl;
        }
    }
}
int main()
{
    pw[1] = 1;
    for( long long i = 2; i <= 6; i ++ )
    {
        pw[i] = pw[i-1] * 10;
    }
    read();
    return 0;
}
