#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e6+2;
long long int n, q, a[maxn], t[4*maxn], lazy[4*maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> q ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i] ;
    }
}

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i] = a[l];
        //lazy[i] = 0;
        return;
    }
    int mid = (l+r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = t[2*i] + t[2*i+1];
}

int find_10(int num, int&idx)
{
    int k = 1;
    while (k <= num)
    {
        k *= 10;
        ++ idx;
    }
    ++ idx;
    return k;
}

void point_update(int i, int l, int r, int&idx)
{
    if (l == r)
    {
        int first = t[i] % 10;
        int second = t[i] / 10;
        int idx = 0;
        int p = find_10(second, idx);
        t[i] = first*p + second;
        a[l] = t[i];
        //cout << l << " " << t[i] << endl;
        return;
    }
    int mid = (l+r) >> 1;
    if (mid >= idx) point_update(2*i, l, mid, idx);
    else point_update(2*i+1, mid+1, r, idx);
    t[i] = t[2*i] + t[2*i+1];
}

long long int query_sum(int i, int l, int r, int ql, int qr)
{
    if (ql<=l && r<=qr) return t[i];
    int mid = (l+r) >> 1;
    if (qr <= mid) return query_sum(2*i, l, mid, ql, qr);
    if (ql > mid) return query_sum(2*i+1, mid+1, r, ql, qr);
    return query_sum(2*i, l, mid, ql, mid) + query_sum(2*i+1, mid+1, r, mid+1, qr);
}

void push_lazy(int&i, int&l, int&r)
{
    if (l != r)
    {
        lazy[2*i] += lazy[i];
        lazy[2*i+1] += lazy[i];
        lazy[i] = 0;
    }
}

void range_update(int i, int l, int r, int&ql, int&qr)
{
    push_lazy(i, l, r);
    if (l>qr || r<ql) return;
    if (ql<=l && r<=qr)
    {
        ++ lazy[i];
        push_lazy(i, l, r);
        return;
    }
    int mid = (l+r) >> 1;
    range_update(2*i, l, mid, ql, qr);
    range_update(2*i+1, mid+1, r, ql, qr);
}

int point_query(int i, int l, int r, int idx)
{
    if (l == r)
    {
        int first = t[i] % 10;
        int second = t[i] / 10;
        int idx = 0;
        int p = find_10(second, idx);
        int k = lazy[i]%idx;
        //cout << lazy[i] endl << endl;
        while (k)
        {
            t[i] = first*p + second;
            first = t[i] % 10;
            second = t[i] / 10;
            -- k;
        }
        a[l] = t[i];
        //cout << l << " " << t[i] << endl;
        return t[i];
    }
    push_lazy(i, l, r);
    int mid = (l+r) >> 1;
    if (mid >= idx) return point_query(2*i, l, mid, idx);
    return point_query(2*i+1, mid+1, r, idx);
}

void solve()
{
    make_tree(1, 1, n);
    int i, type, ql, qr, j;
    for (i=1; i<=q; ++i)
    {
        cin >> type >> ql >> qr ;
        if (type == 1)
        {
            /*for (j=x; j<=y; ++j)
            {
                //cout << "***" << j <<endl;
                point_update(1, 1, n, j);
            }*/
            range_update(1, 1, n, ql, qr);
        }
        else
        {
            //cout << query_sum(1, 1, n, x, y) << endl;
            cout << point_query(1, 1, n, ql) << endl;
        }
    }
}

int main()
{
    read();
    solve();
    return 0;
}

/*
3 7
15 35 112
2 3 3
1 2 3
1 1 3
1 3 3
1 2 3
1 3 3
2 3 3
*/