#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
vector<int> a;

void read() {
    cin >> n >> q;

    a.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
}

void flip(int l, int r) {
    for (int i = l; i <= r; i++) {
        string str = to_string(a[i]);
        str = str.back() + str;
        str.pop_back();
        a[i] = stoi(str);
    }
}

long long query(int l, int r) {
    long long total = 0;
    for (int i = l; i <= r; i++) {
        total += a[i];
    }

    return total;
}

void solve() {
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;

        if (type == 1) {
            flip(l, r);
        } else {
            cout << query(l, r) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
