# include <bits/stdc++.h>
using namespace std;
const int maxn= 2e6+5;

const int MOD = 1e9+7;
int ans[maxn];
const int P = 3000;
vector <pair <int,int> > h;
vector <pair <int,int>  > t;
int pows[3005][3005];
struct Segment
{
    vector <int> segm[maxn];
    void update(int v, int from, int to, int l, int r,int num)
    {
        //cout<<v<<" "<<from<<" "<<to<<" "<<l<<" "<<r<<" "<<num<<endl;
        if(l<=from&&to<=r)
        {
            segm[v].push_back(num);
            return ;
        }
        int mid  = (from+to)/2;
        if(l<=mid)
            update(2*v,from,mid,l,r,num);
        if(r>mid)
            update(2*v+1,mid+1,to,l,r,num);
        return ;
    }
    void calc(int x)
    {
        t.clear();
        for(auto u:h)
        {
            t.push_back(u);
        }
        for(auto u:h)
        {
            //  cout<<x<<" "<<u.first<<endl;
            int l = pows[x][u.first];
            t.push_back({l,u.second});
        }
        t.push_back({x,1});
        h.clear();
        sort(t.begin(),t.end());
        for(int i = 0; i<t.size(); i++)
        {
            long long sum = t[i].second;
            int j = i+1;
            while(j<t.size()&&t[j].first==t[i].first)
            {
                sum  = (sum+t[j].second)%MOD;
                j++;
            }
            i = j-1;
            h.push_back({t[i].first,sum});
        }
    }
    void query(int v, int from, int to)
    {
        //  cout<<v<<" "<<from<<" "<<to<<endl;

       vector <pair <int,int> > z;
       z = h;
        for(auto u:segm[v])
        {
            //   cout<<"add "<<u<<endl;
            calc(u);
        }
        if(from==to)
        {
            long long ANS = 0;
            for(auto u: h)
            {
                //  if(sol[i]!=0)
                //  cout<<sol[i]<<" :: "<<i<<endl;
                ANS = (ANS + u.first*u.second)%MOD;

            }
            ans[from] = ANS;

        }
        if(from!=to)
        {
            int mid = (from+to)/2;
            query(2*v,from,mid);
            query(2*v+1,mid+1,to);
        }
        h.clear();
        h = z;
        return ;
    }
};
Segment S;
int ids[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,x,q;
    cin>>n>>q;
    int i,j,t;
    for(i = 1; i<=n; i++)
    {
        cin>>x;
        ids[x] = 1;
    }

    for(i = 1; i<=q; i++)
    {
        cin>>t>>x;
        if(t==1)
        {
            ids[x] = i+1;
        }
        else
        {
            S.update(1,1,q+1,ids[x],i,x);
            ids[x] = 0;
        }
    }
    for(i = 1; i<=P; i++)
    {
        if(ids[i]!=0)
        {
            S.update(1,1,q+1,ids[i],q+1,i);
        }
    }
    for(i = 1;i<=P;i++)
        for(j=1;j<=P;j++)
        pows[i][j] = __gcd(i,j);
    S.query(1,1,q+1);
    for(i=1; i<=q+1; i++)
        cout<<ans[i]<<endl;

}
