# include <bits/stdc++.h>
using namespace std;
const int maxn = 4e6+5;
int a[maxn];
const int MOD = 1e9+7;
struct Segment
{
    int segm[maxn][6][6];
    void build(int v, int from,int to)
    {
        if(from==to)
        {

            int x = a[from];
            int nums = 0;
            while(x!=0)
            {
                x/=10;
                nums++;
            }
            x = a[from];
            int i=0;
            while(x!=0)
            {
             //   cout<<from<<" : "<<nums-1<<" "<<i<<" :: "<<x%10<<endl;
                segm[v][nums-1][i]=x%10;
                i++;
                x/=10;
            }
            return ;
        }
        int mid = (from+to)/2;
        build(2*v,from,mid);
        build(2*v+1,mid+1,to);
        for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
        }
    }
    void update(int v, int from, int to, int d)
    {
        if(from==to)
        {
            int i,j,prev;
            for(i =0;i<6;i++)
            {
                prev = segm[v][i][0];
                for(j = 0;j<i;j++)
                {
                    segm[v][i][j] = segm[v][i][j+1];
                }
                segm[v][i][i] = prev;
            }
            return ;
        }
        int mid = (from+to)/2;
        if(d<=mid)update(2*v,from,mid,d);
        else
            update(2*v+1,mid+1,to,d);
         for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
        }
        return ;
    }
    int query(int v, int from, int to, int l, int r)
    {
        long long ans = 0,i,j;
        if(l<=from&&to<=r)
        {
            for(i=0;i<6;i++)
            {
                long long pow = 1;
                for(j=0;j<6;j++)
                {
                    ans = (ans + segm[v][i][j]*pow)%MOD;
                    pow*=10;
                }
            }
            return ans;
        }
        int mid = (from+to)/2;
        if(l<=mid)ans+=query(2*v,from,mid,l,r);
        if(r>mid)ans+=query(2*v+1,mid+1,to,l,r);
        return ans%MOD;
    }
};
Segment S;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin>>n>>q;
    int i;
    for(i = 1;i<=n;i++)
    {
        cin>>a[i];
    }
    S.build(1,1,n);
    int type,l,r;
    for(i=1;i<=q;i++)
    {
        cin>>type>>l>>r;
        if(type==1)
        {
            S.update(1,1,n,l);
        }
        else
        {
            int ans = S.query(1,1,n,l,r);
            cout<<ans<<endl;
        }
    }
}
