#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=2e5+6;
const int MAXA=3002;
const ll mod=1e9+7;
int n,q;
ll cnt[MAXA];
ll cnt_real[MAXA];
vector<int>divs[MAXA];
void add(int u)
{
    for(auto xd:divs[u])
    {
        ++cnt[xd];
    }
}
void rmv(int u)
{
    for(auto xd:divs[u])
    {
        --cnt[xd];
    }
}
void precompute()
{
    for(int i=1;i<MAXA;++i)
    {
        for(int j=i;j<MAXA;j+=i)
        {
            divs[j].push_back(i);
        }
    }
}
ll fastpow(ll x,ll p)
{
    if(p==1)return x;
    if(p==0)return 1;
    ll t=fastpow(x,p/2);
    t*=t;t%=mod;
    if(p%2==1)
    {
        t*=x;t%=mod;
    }
    return t;
}
int calc()
{
    ll ans=0;
    for(ll j=MAXA-1;j>=1;--j)
    {
        cnt_real[j]=(mod+fastpow(2,cnt[j])-1ll)%mod;
        for(int l=j*2;l<MAXA;l+=j)
        {
            cnt_real[j]+=mod-cnt_real[l];
            cnt_real[j]%=mod;
        }
        //if(cnt_real[j]!=0)cout<<j<<" "<<cnt_real[j]<<endl;
        ans+=1ll*cnt_real[j]*j;
        ans%=mod;
    }
    return ans;
}
int main()
{
    precompute();
    cin>>n>>q;
    for(int i=1;i<=n;++i)
    {
        int a;
        cin>>a;
        add(a);
    }
    cout<<calc()<<endl;
    for(int i=1;i<=q;++i)
    {
        int t,x;
        cin>>t>>x;
        if(t==1)add(x);
        else rmv(x);
        cout<<calc()<<endl;
    }
return 0;
}
