#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=1e6+6;
ll arr[MAXN];
ll cd[MAXN];
ll pw10[8];
int n,q;
struct node
{
    vector<ll>sums;
    ll ptr;
};
node mergen(node n1,node n2)
{
    node ret;
    ret.ptr=0;
    ret.sums={};
    for(int j=0;j<n1.sums.size();j++)
    {
        ret.sums.push_back(n1.sums[(j+n1.ptr)%n1.sums.size()]+n2.sums[(j+n2.ptr)%n2.sums.size()]);
    }
    return ret;
}
node make_node(ll num,int cntd)
{
    node ret;
    ret.ptr=0;
    ret.sums={};
    for(int j=0;j<cntd;j++)
    {
        ret.sums.push_back((num/pw10[j])%10);
    }
    return ret;
}
ll make_number(node f)
{
    ll ret=0;
    for(ll j=0;j<f.sums.size();j++)
    {
        ll j1=(f.ptr+j)%f.sums.size();
        ret+=pw10[j]*f.sums[j1];
    }
    return ret;
}
struct segment_tree
{
    node tree[3*MAXN];
    int lazy[3*MAXN];
    ll cntdig;
    void build(int l,int r,int idx)
    {
        lazy[idx]=0;
        if(l==r)
        {
            if(cd[l]==cntdig)tree[idx]=make_node(arr[l],cntdig);
            else tree[idx]=make_node(0,cntdig);;
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    void push(int l,int r,int idx)
    {
        if(lazy[idx]==0)return;
        tree[idx].ptr=(tree[idx].ptr+lazy[idx])%cntdig;
        if(l!=r)
        {
            lazy[idx*2]+=lazy[idx];
            lazy[idx*2+1]+=lazy[idx];
        }
        lazy[idx]=0;
    }
    void update(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(ql>r)return;
        if(l>qr)return;
        if(l>=ql&&r<=qr)
        {
            lazy[idx]++;
            push(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr);
        update(mid+1,r,idx*2+1,ql,qr);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    node query(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return mergen(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tt[7];
void precompute()
{
    pw10[0]=1;
    for(int i=1;i<8;i++)
    {
        pw10[i]=pw10[i-1]*10;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    precompute();
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>arr[i];
        if(arr[i]>=10)
        if(arr[i]>=100)
        if(arr[i]>=1000)
        if(arr[i]>=10000)
        if(arr[i]>=100000) cd[i]=6;
        else cd[i]=5;
        else cd[i]=4;
        else cd[i]=3;
        else cd[i]=2;
        else cd[i]=1;
    }
    for(int i=1;i<=6;i++)
    {
        tt[i].cntdig=i;
        tt[i].build(1,n,1);
    }
    for(int i=0;i<q;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            for(int j=1;j<=6;j++)
            {
                tt[j].update(1,n,1,l,r);
            }
        }
        else
        {
            ll ans=0;
            for(int j=1;j<=6;j++)
            {
                //cout<<j<<" "<<make_number(tt[j].query(1,n,1,l,r))<<endl;
                ans+=make_number(tt[j].query(1,n,1,l,r));
            }
            cout<<ans<<endl;
        }
    }
return 0;
}
