#include<bits/stdc++.h>
using namespace std;
#define ll long long
#pragma GCC optimize ("Ofast")

const int MAXN=1e6+6;
ll arr[MAXN];
ll cd[MAXN];
ll arr1[MAXN];
ll pw10[8];
int n,q;
int c_now;
struct node
{
    int sums[6];
    int ptr;
};
node mergen(node n1,node n2)
{
    node ret;
    ret.ptr=0;
    for(int j=0;j<c_now;++j)
    {
        ret.sums[j]=(n1.sums[(j+n1.ptr)%c_now]+n2.sums[(j+n2.ptr)%c_now]);
    }
    return ret;
}
node make_node(int num,int cntd)
{
    node ret;
    ret.ptr=0;
    for(int j=0;j<cntd;++j)
    {
        ret.sums[j]=((num/pw10[j])%10);
    }
    return ret;
}
ll make_number(node f)
{
    ll ret=0;
    for(int j=0;j<c_now;++j)
    {
        int j1=(f.ptr+j)%c_now;
        ret+=pw10[j]*f.sums[j1];
    }
    return ret;
}
struct segment_tree
{
    node tree[3*MAXN];
    int lazy[3*MAXN];
    ll cntdig;
    void build(int l,int r,int idx)
    {
        lazy[idx]=0;
        if(l==r)
        {
            tree[idx]=make_node(arr1[l],cntdig);
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    void push(int l,int r,int idx)
    {
        if(lazy[idx]==0)return;
        tree[idx].ptr=(tree[idx].ptr+lazy[idx])%cntdig;
        if(l!=r)
        {
            lazy[idx*2]+=lazy[idx];
            lazy[idx*2+1]+=lazy[idx];
        }
        lazy[idx]=0;
    }
    void update(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(ql>r)return;
        if(l>qr)return;
        if(l>=ql&&r<=qr)
        {
            ++lazy[idx];
            push(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr);
        update(mid+1,r,idx*2+1,ql,qr);
        tree[idx]=mergen(tree[idx*2],tree[idx*2+1]);
    }
    node query(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return mergen(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tt;
set<int>where;
void precompute()
{
    pw10[0]=1;
    for(int i=1;i<8;++i)
    {
        pw10[i]=pw10[i-1]*10;
    }
}
ll ans[MAXN];
struct query
{
    int t,l,r;
}zaqvki[MAXN];
int idx1[MAXN];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    precompute();
    cin>>n>>q;
    for(int i=1;i<=n;++i)
    {
        cin>>arr[i];
        if(arr[i]>=10)
        if(arr[i]>=100)
        if(arr[i]>=1000)
        if(arr[i]>=10000)
        if(arr[i]>=100000) cd[i]=6;
        else cd[i]=5;
        else cd[i]=4;
        else cd[i]=3;
        else cd[i]=2;
        else cd[i]=1;
    }
    for(int i=0;i<q;++i)
    {
        cin>>zaqvki[i].t>>zaqvki[i].l>>zaqvki[i].r;
    }
    for(int c=1;c<=6;++c)
    {
        c_now=c;
        where.clear();
        for(int i=1;i<=n;++i)
        {
            if(cd[i]==c)
            {
                where.insert(i);
                arr1[where.size()]=arr[i];
                idx1[i]=where.size();
            }
        }
        if(where.size()==0)continue;
        tt.cntdig=c;
        tt.build(1,where.size(),1);
        /*cout<<"arr1\n";
        for(int i=1;i<=where.size();i++)cout<<arr1[i]<<" ";
        cout<<endl;*/
        for(int i=0;i<q;++i)
        {
            //cout<<c<<" "<<i<<endl;
            int t=zaqvki[i].t;
            int l=zaqvki[i].l;
            auto it=where.lower_bound(l);
            if(it==where.end())continue;
            l=idx1[(*it)];
            int r=zaqvki[i].r;
            it=where.lower_bound(r+1);
            if(it==where.begin())continue;
            it--;
            r=idx1[(*it)];
            //cout<<"  "<<l<<" "<<r<<endl;
            if(t==1)
            {
                if(l<=r)tt.update(1,where.size(),1,l,r);
            }
            else
            {
                if(l<=r)ans[i]+=make_number(tt.query(1,where.size(),1,l,r));
            }
        }
        /*cout<<"ans:\n";
        for(int i=0;i<q;i++)
        {
            cout<<ans[i]<<endl;
        }*/
    }
    for(int i=0;i<q;++i)
    {
        if(zaqvki[i].t==2)cout<<ans[i]<<"\n";
    }
return 0;
}
