#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e6+6;

int a[MAXN];
int n, q;

int rot(int a)
{
    int brc = 0;
    int t = a;
    while (t) brc++, t /= 10;

    int p = 1;
    for (int i = 0; i < brc - 1; i++)
        p *= 10;

    return a % 10 * p + a / 10;
}

int prefix[MAXN];

void upd(int l, int r)
{
    for (int i = l; i <= r; i++)
        a[i] = rot(a[i]);

    for (int i = l; i <= n; i++)
        prefix[i] = prefix[i-1] + a[i];
}

int query(int l, int r)
{
    int ret = prefix[r] - prefix[l - 1];

    return ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        prefix[i] = prefix[i-1] + a[i];
    }


    for (int i = 1; i <= q; i++)
    {
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1) upd(l, r);
        else cout << query(l, r) << endl;
    }

    return 0;
}
/**
3 5
15 35 112
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3


50
279
246

*/
