#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e6+6;

long long a[MAXN];
int n, q;

long long rot(long long a)
{
    int brc = 0;
    long long t = a;
    while (t) brc++, t /= 10;

    long long p = 1;
    for (int i = 0; i < brc - 1; i++)
        p *= 10;

    return a % 10 * p + a / 10;
}

struct My
{
    int l, r;
    long long val;
    My () {};
    My (int _l, int _r, long long _val)
    {
        l = _l, r = _r, val = _val;
    }
};

long long prefix[MAXN];
vector <My> updates;

void upd(int l, int r)
{
    updates.push_back(My(l, r, rot(a[l]) - a[l]));

    for (int i = l; i <= r; i++)
        a[i] = rot(a[i]);

//    for (int i = l; i <= n; i++)
//        prefix[i] = prefix[i-1] + a[i];
}

long long query(int l, int r)
{
    long long ret = prefix[r] - prefix[l - 1];

    for (auto update: updates)
    {
        if (update.l >= l && update.r <= r)
            ret += update.val;
    }

    return ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        prefix[i] = prefix[i-1] + a[i];
    }

    for (int i = 1; i <= q; i++)
    {
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1) upd(l, r);
        else cout << query(l, r) << endl;
    }

    return 0;
}
/**
3 5
15 35 112
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3

50
279
246


3 6
15 35 112
1 2 2
2 1 3
1 2 2
2 1 3
1 2 2
2 1 3

2->53

50
180
165

*/
