#pragma GCC optimize "Ofast"
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e6+5;
struct Node
{
    long long val;
    int rot[65];
    int ptr;
    int mod;
};
int n,q;
int a[MAXN];
Node tree[4*MAXN];
int lazy[4*MAXN];

int mod(int node,int x)
{
    x=x%tree[node].mod;
    if(!x) x=tree[node].mod;
    return x;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node].val=a[l];
        for(int i=1, j=1;;i*=10, j++)
        {
            if(a[l]/i<10)
            {
                tree[node].mod=j;
                break;
            }
        }
        int tmp=a[l];
        int diff=0;
        for(int i=1;i<=tree[node].mod;i++) ///
        {
            diff=tmp;
            tmp=tmp/10+(tmp%10)*pow(10,tree[node].mod-1);
            diff=tmp-diff;
            tree[node].rot[i]=diff;
            //cout<<l<<" "<<r<<" "<<i<<" "<<tree[node].rot[i]<<endl;
        }
        tree[node].ptr=1; ///
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node].val=tree[2*node].val+tree[2*node+1].val;
    int lcm=tree[2*node].mod*tree[2*node+1].mod/__gcd(tree[2*node].mod, tree[2*node+1].mod);
    tree[node].mod=lcm;
    for(int i=1;i<=lcm;i++)
    {
        tree[node].rot[i]=tree[2*node].rot[mod(2*node,i)]+tree[2*node+1].rot[mod(2*node+1,i)];
    }
    tree[node].ptr=1;
}

void push(int node,int l,int r)
{
    for(int i=0;i<lazy[node];i++)
    {
        tree[node].val+=tree[node].rot[tree[node].ptr];
        tree[node].ptr++;
        if(tree[node].ptr>tree[node].mod) tree[node].ptr=1;
    }
    if(l!=r)
    {
        lazy[2*node]+=lazy[node];
        lazy[2*node+1]+=lazy[node];
    }
    lazy[node]=0;
}

void update(int node,int l,int r,int b,int e)
{
    push(node,l,r);
    if(e<l || r<b) return;
    if(b<=l && r<=e)
    {
        tree[node].val+=tree[node].rot[tree[node].ptr];
        tree[node].ptr++;
        if(tree[node].ptr>tree[node].mod) tree[node].ptr=1;
        if(l!=r)
        {
            lazy[2*node]++;
            lazy[2*node+1]++;
        }
        return;
    }
    int mid=(l+r)/2;
    update(2*node,l,mid,b,e);
    update(2*node+1,mid+1,r,b,e);
    tree[node].val=tree[2*node].val+tree[2*node+1].val;
    for(int i=1;i<=tree[node].mod;i++)
    {
        tree[node].rot[i]=tree[2*node].rot[mod(2*node, tree[2*node].ptr+i-1)] + tree[2*node+1].rot[mod(2*node+1, tree[2*node+1].ptr+i-1)];
    }
    tree[node].ptr=1;
}

long long query(int node,int l,int r,int b,int e)
{
    push(node,l,r);
    if(e<l || r<b) return 0;
    if(b<=l && r<=e) return tree[node].val;
    int mid=(l+r)/2;
    return query(2*node,l,mid,b,e) + query(2*node+1,mid+1,r,b,e);
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n>>q;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
build(1,1,n);
for(int i=0;i<q;i++)
{
    int type,l,r;
    cin>>type>>l>>r;
    if(type==1)
    {
        update(1,1,n,l,r);
    }
    else
    {
        cout<<query(1,1,n,l,r)<<endl;
    }
}
return 0;
}
