#include <iostream>
using namespace std;
const long long mod=1e9+7;
long long a[32], br;
void add(long long x) {
    int ind;
    for (int i=0;i<br;i++) {
        if (a[i]==x) {
            ind=i;
            break;
        }
    }
    for (int i=br+1;i>ind;i--) a[i]=a[i-1];
    a[ind]=x;
    br++;
}
void rem(long long x) {
    int ind;
    for (int i=0;i<br;i++) {
        if (a[i]==x) {
            ind=i;
            break;
        }
    }
    for (int i=ind;i<br-1;i++) a[i]=a[i+1];
    br--;
}
long long NOD(long long a, long long b) {
    if (a==0) return b;
    long long r;
    while (b>0) {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}
long long query() {
    long long ans=0, k, i, s;
    for (int mask=0;mask<(1<<br);mask++) {
        k=mask;
        i=s=0;
        while (k>0) {
            if (k%2==1) s=NOD(s,a[i]);
            i++;
            k/=2;
        }
        ans+=s;
    }
    return ans%mod;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i=0;i<n;i++) cin >> a[i];
    br=n;
    cout << query() << endl;
    int type, x;
    for (int i=0;i<q;i++) {
        cin >> type >> x;
        if (type==1) add(x);
        else rem(x);
        cout << query() << endl;
    }
    return 0;
}
