#include <bits/stdc++.h>

#define MAX_N 10
#define MAX_Q 10

#define MOD 1'000'000'007

int64_t n;
int64_t q;

int64_t set_len;
int64_t set[MAX_N+MAX_Q];

int64_t calc_gcd_sum_for_bitmask(int64_t bitmask) {
	int64_t ret = 0;
	for (int64_t i = 0; i < set_len; i += 1) {
		if (!(bitmask & 1)) {
			bitmask >>= 1;
			continue;
		}
		ret = std::__gcd(ret, set[i]);
		bitmask >>= 1;
	}
	return ret;
}

int64_t calc_gcd_sum() {
	int64_t ret = 0;
	for (int64_t i = 0; i < (1 << set_len); i += 1) {
		ret += calc_gcd_sum_for_bitmask(i);
		ret %= MOD;
	}
	return ret;
}

int main() {
	scanf("%lld%lld", &n, &q);
	
	for (int64_t i = 0; i < n; i += 1) {
		scanf("%lld", &set[set_len]);
		set_len += 1;
	}	
	printf("%lld\n", calc_gcd_sum());
	
	for (int64_t i = 0; i < q; i += 1) {
		int64_t type, x;
		scanf("%lld%lld", &type, &x);
		if (type == 1) {
			set[set_len] = x;
			set_len += 1;
		} else {
			for (int64_t j = 0; j < set_len; j += 1) {
				if (set[j] == x) {
					std::swap(set[j], set[set_len-1]);
					break;
				}
			}
			set_len -= 1;
		}
		printf("%lld\n", calc_gcd_sum());
	}
}