#include <bits/stdc++.h>

#define MAX_N 200'000
#define MAX_Q 0

#define MOD 1'000'000'007

int64_t n;
int64_t q;

std::unordered_map<int64_t, int64_t> gcd_count;

int main() {
	scanf("%lld%lld", &n, &q);
	
	for (int64_t i = 0; i < n; i += 1) {
		int64_t x;
		scanf("%lld", &x);

		for (auto it: gcd_count) {
			int64_t cur_gcd = std::__gcd(x, it.first);
			
			if (gcd_count.find(cur_gcd) == gcd_count.end()) gcd_count[cur_gcd]  = it.second;
			else                                            gcd_count[cur_gcd] += it.second;
			
			gcd_count[cur_gcd] %= MOD;
		}
		
		if (gcd_count.find(x) == gcd_count.end()) gcd_count[x]  = 1;
		else                                      gcd_count[x] += 1;

	}
	
	int64_t sum = 0;
	for (auto it: gcd_count) {
		sum += it.first * it.second;
		sum %= MOD;
	}
	printf("%lld\n", sum);
}