#include <bits/stdc++.h>

#define MAX_N 5000

struct Number {
	int64_t value;
	int64_t next_power_of_ten;
};

int64_t n, q;

Number arr[MAX_N];

int calc_next_power_of_ten(int64_t x) {
	int64_t p = 1;
	while (x / p > 0) p *= 10;
	return p;
}

void rot(int64_t l, int64_t r) {
	for (int64_t i = l; i <= r; i += 1) {
		arr[i].value += arr[i].next_power_of_ten * (arr[i].value % 10);
		arr[i].value /= 10;
	}
}

int64_t sum(int64_t l, int64_t r) {
	int64_t ret = 0;
	for (int64_t i = l; i <= r; i += 1) {
		ret += arr[i].value;
	}
	return ret;
}

int main() {
	scanf("%lld%lld", &n, &q);
	for (int64_t i = 0; i < n; i += 1) {
		scanf("%lld", &arr[i].value);
		arr[i].next_power_of_ten = calc_next_power_of_ten(arr[i].value);
	}
	
	for (int i = 0; i < q; i += 1) {
		int64_t type, l, r;
		scanf("%lld%lld%lld", &type, &l, &r);
		l -= 1;
		r -= 1;
		if (type == 1) rot(l, r);
		else           printf("%lld\n", sum(l, r));
	}
}