#include <iostream>
#include <set>
#include <algorithm>
#include <unordered_set>
using namespace std;
#define endl '\n'
#define int long long
#define uset unordered_set
int br, q;
set<int> us;
int cgcd(uset<int>& par)
{
    if(par.empty()) return 0;
    int res = *(par.begin());
    for(int i : par){
        res = __gcd(res, i);
    }
    return res;
}
int ans;
void rec(uset<int> par, int ngcd)
{
    if(par.size() == us.size()){
        ans += ngcd; return;
    }
    ans += ngcd;
    for(int i : us){
        if(par.find(i) != par.end()) continue;
        int newgcd = __gcd(ngcd, i); par.insert(i);
        rec(par, newgcd); par.erase(i);
    }
}
int getat(int pos)
{
    int cnt = 0;
    for(int i : us){
        if(cnt < pos){
            ++cnt; continue;
        }
        return i;
    }
}
int calculate()
{
    int power = (1 << ((int) us.size()));
    int sum = 0;
    for(int i = 1; i < power; ++i){
        int res = -1;
        int cur = 1, cnt = 0;
        while(cur <= i){
            if((i & cur) != 0){
                if(res == -1) res = getat(cnt);
                else res = __gcd(res, getat(cnt));
            }
            cur *= 2; cnt++;
        }
        sum += res;
    }
    return sum;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br >> q;
    for(int i = 0; i < br; ++i){
        int input; cin >> input;
        us.insert(input);
    }
    cout << calculate() << endl;
    for(int i = 0; i < q; ++i){
        int t, input; cin >> t >> input;
        if(t == 1) us.insert(input);
        else us.erase(input);
        cout << calculate() << endl;
    }

    return 0;
}

