#include<bits/stdc++.h>
#define MAXN 1000007
using namespace std;

int n,q,a[MAXN];
int temp[6],type,from,to;
long long sb,prenos;
int d,power[8];

struct node{
    int sum[6];
    int lazy;

    void shiftp(int d,int x){

        for(int i=0;i<d;i++){
            temp[i]=sum[(i+x)%d];
        }
        for(int i=0;i<d;i++){
            sum[i]=temp[i];
        }
    }

    long long calc(){
        sb=0;prenos=0;
        for(int i=0;i<6;i++){
            sb+=((sum[i]+prenos)%10)*power[i];
            prenos=(sum[i]+prenos)/10;
        }
        sb+=power[7]*prenos;
        return sb;
    }
};

node tree[6][4*MAXN];

int dig(int x){
    if(x<=9)return 1;
    if(x<=99)return 2;
    if(x<=999)return 3;
    if(x<=9999)return 4;
    if(x<=99999)return 5;
    if(x<=999999)return 6;
}
int getdig(int x,int pos){
    return (x/power[pos])%10;
}

node combine(node fr,node sc){
    for(int i=0;i<6;i++)fr.sum[i]+=sc.sum[i];
    fr.lazy=0;
    return fr;
}

void build(int v,int l,int r){
    if(l==r){
        d=dig(a[l]);
        for(int i=0;i<d;i++){
            tree[d-1][v].sum[i]=getdig(a[l],i);
        }
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        for(int i=0;i<6;i++)tree[i][v]=combine(tree[i][2*v],tree[i][2*v+1]);
    }
}

void psh(int id,int v){
    tree[id][2*v].shiftp(id+1,tree[id][v].lazy);
    tree[id][2*v+1].shiftp(id+1,tree[id][v].lazy);

    tree[id][2*v].lazy+=tree[id][v].lazy;
    tree[id][2*v].lazy%=(id+1);
    tree[id][2*v+1].lazy+=tree[id][v].lazy;
    tree[id][2*v+1].lazy%=(id+1);

    tree[id][v].lazy=0;
}

void update(int id,int v,int l,int r,int ll,int rr){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[id][v].shiftp(id+1,1);
        tree[id][v].lazy++;
        tree[id][v].lazy%=(id+1);
    }else{
        psh(id,v);
        int tt=(l+r)/2;
        update(id,2*v,l,tt,ll,min(tt,rr));
        update(id,2*v+1,tt+1,r,max(tt+1,ll),rr);
        tree[id][v]=combine(tree[id][2*v],tree[id][2*v+1]);
    }
}

long long res;

long long getsum(int v,int l,int r,int ll,int rr){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        res=0;
        for(int i=0;i<6;i++)res+=tree[i][v].calc();
        return res;
    }else{
        for(int i=0;i<6;i++)psh(i,v);

        int tt=(l+r)/2;
        return getsum(2*v,l,tt,ll,min(tt,rr)) + getsum(2*v+1,tt+1,r,max(tt+1,ll),rr);
    }
}

int main(){
    
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    power[0]=1;
    for(int i=1;i<8;i++)power[i]=power[i-1]*10;

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    build(1,1,n);

    for(int i=1;i<=q;i++){
        cin>>type>>from>>to;
        if(type==1){
            for(int f=0;f<6;f++)update(f,1,1,n,from,to);
        }else{
            cout<<getsum(1,1,n,from,to)<<"\n";
        }
    }

    return 0;
}
