#pragma GCC optimize ("O3")
#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

long long sum[4000003],num[1000003],ans;

void build_tree(long long l,long long r,long long now){
    if(l==r){
        sum[now]=num[l];
        return ;
    }
    long long mid=(l+r)/2;
    build_tree(l,mid,now*2+1);
    build_tree(mid+1,r,now*2+2);
    sum[now]=sum[now*2+1]+sum[now*2+2];
}

void change_tree_once(long long l,long long r,long long wh,long long now){
    if(l==wh && r==wh){
        sum[now]=num[l];
        return ;
    }
    long long mid=(l+r)/2;
    if(mid>=wh)change_tree_once(l,mid,wh,now*2+1);
    if(mid+1<=wh)change_tree_once(mid+1,r,wh,now*2+2);
    sum[now]=sum[now*2+1]+sum[now*2+2];
}

void find_sum(long long l,long long r,long long L,long long R,long long now){
    if(l>R || r<l)return ;
    if(l>=L && r<=R){
        ans+=sum[now];
        return ;
    }

    long long mid=(l+r)/2;
    if(mid>=L)find_sum(l,mid,L,R,now*2+1);
    if(mid+1<=R)find_sum(mid+1,r,L,R,now*2+2);
}

int main(){

    long long n,q;
    cin>>n>>q;

    for(int i=0;i<n;i++){
        cin>>num[i];
    }
    build_tree(0,n-1,0);

    //if(n>5000){
        long long a,L,R;
        for(int i=0;i<q;i++){
            cin>>a>>L>>R;
            L--;R--;
            if(a==1){
                long long br=0,c;
                c=num[L];
                while(c>0){
                    c/=10;
                    br++;
                }
                num[L]=num[L]/10+(num[L]%10)*(pow(10,br-1)+0.3);
                change_tree_once(0,n-1,L,0);
            }else{
                ans=0;
                find_sum(0,n-1,L,R,0);
                cout<<ans<<endl;
            }
        }
    //}

    return 0;
}
