#include<bits/stdc++.h>
#define lli long long int
#define endl "\n"
using namespace std;
const lli MAXN=1000006;
lli tree[4*MAXN], a[MAXN], N, Q, vh1, vh2, vh3, lazy[4*MAXN];
void build(lli ind, lli l, lli r){
    lazy[ind]=0;
    if(l==r){
        tree[ind]=0;
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    tree[ind]=tree[2*ind]+tree[2*ind+1];
    return;
}
lli rotate(lli ans){
    lli st=1, x=ans%10;
    ans/=10;
    while(st<=ans){
        st*=10;
    }
    ans+=x*st;
    return ans;
}
void push_lazy(lli ind, lli l, lli r){
    if(l==r){
        tree[ind]+=lazy[ind];
        lazy[ind]=0;
        return;
    }
    tree[ind]+=lazy[ind]*(r-l+1);
    lazy[2*ind]+=lazy[ind];
    lazy[2*ind+1]+=lazy[ind];
    lazy[ind]=0;
    return;
}
void update(lli ind, lli l, lli r, lli ql, lli qr){
    if(l>qr or r<ql)return;
    push_lazy(ind, l, r);
    if(ql<=l and r<=qr){
        lazy[ind]++;
        return;
    }
    lli mid=(l+r)/2;
    update(2*ind, l, mid, ql, qr);
    update(2*ind+1, mid+1, r, ql, qr);
    tree[ind]=tree[2*ind]+tree[2*ind+1];
    return;
}
lli query(lli ind, lli l, lli r, lli ql, lli qr){
    if(l>qr or r<ql)return 0;
    push_lazy(ind, l, r);
    if(ql<=l and r<=qr)return tree[ind];
    lli mid=(l+r)/2;
    return query(2*ind, l, mid, ql, qr)+query(2*ind+1, mid+1, r, ql, qr);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>Q;
    for(lli i=1; i<=N; i++){
        cin>>a[i];
    }
    build(1, 1, N);
    for(lli i=0; i<Q; i++){
        cin>>vh1>>vh2>>vh3;
        if(vh1==1){
            update(1, 1, N, vh2, vh3);
        }else{
            lli br=query(1, 1, N, vh2, vh3), ans=a[vh2];
            for(lli j=0; j<br; j++){
                ans=rotate(ans);
            }
            cout<<ans<<endl;
        }
    }
    return 0;
}