#include <iostream>
using namespace std;
int sums[1000000];
int magnitude(int x) {
    if (x == 0) {
        return 0;
    }
    return magnitude(x / 10) + 1;
}
int force(int x, int y) {
    if (y == 0) {
        return 1;
    }
    return force(x, y - 1) * x;
}
int a[1000000], n, m;
int sum(int l, int r) {
    if (l == r) {
        return a[l];
    }
    return a[l] + sum(l + 1, r);
}
void update(int l, int r, int change) {
    if (l <= r) {
        int prev = a[l];
        a[l] = a[l] / 10 + (a[l] % 10) * force(10, magnitude(a[l]) - 1);
        change += a[l] - prev;
        sums[l] += change;
        update(l + 1, r, change);
    } else if (l < n) {
        sums[l] += change;
    }
}
int main () {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sums[i] = a[i];
        if (i != 0) {
            sums[i] += sums[i - 1];
        }
    }
    for (int i = 0; i < m; i++) {
        int q, l, r;
        cin >> q >> l >> r;
        l--;
        r--;
        if (q == 1) {
            update(l, r, 0);
        }
        if (q == 2) {
            if (left == 0) {
                cout << sums[r];
                continue;
            }
            cout << sums[r] - sums[l - 1] << endl;
        }
//        cout << "\n(((\n";
//        for (int j = 0; j < n; j++) {
//            cout << a[j] << " " << sums[j] << "\n";
//        }
//        cout << ")))\n";
    }
    return 0;
}
