#include<iostream>
#define endl '\n'
using namespace std;
long long a[1000005],tree[3][4000005],lazy[4000005];
void build(long long node,long long l,long long r)
{
    if(l==r)
    {
        long long p=a[l];
        for(long long i=1;i<=2;i++)
        {
            tree[i][node]=p%10;
            p/=10;
        }
        return;
    }
    long long mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[1][node]=tree[1][2*node]+tree[1][2*node+1];
    tree[2][node]=tree[2][2*node]+tree[2][2*node+1];
}
void update(long long node,long long l,long long r,long long le,long long ri)
{
    if(l>=le && r<=ri)
        lazy[node]+=1;

    lazy[node]%=2;

    if(lazy[node])
    {
        swap(tree[1][node],tree[2][node]);
        if(l!=r)
        {
            lazy[2*node]+=lazy[node];
            lazy[2*node+1]+=lazy[node];
        }
        lazy[node]=0;
    }
    if((l>=le && r<=ri) || (l>ri || r<le)) return;

    long long mid=(l+r)/2;

    update(2*node,l,mid,le,ri);
    update(2*node+1,mid+1,r,le,ri);

     tree[1][node]=tree[1][2*node]+tree[1][2*node+1];
    tree[2][node]=tree[2][2*node]+tree[2][2*node+1];
}
long long query(long long node,long long l,long long r,long long le,long long ri)
{
    lazy[node]%=2;
    if(lazy[node])
    {
        swap(tree[1][node],tree[2][node]);
        if(l!=r)
        {
            lazy[2*node]+=lazy[node];
            lazy[2*node+1]+=lazy[node];
        }
        lazy[node]=0;
    }
    if((l>ri || r<le)) return 0;
    if(l>=le && r<=ri)
    {
        return (10*tree[2][node]+tree[1][node]);
    }
    long long mid=(l+r)/2,r1,r2;

    r1=query(2*node,l,mid,le,ri);
    r2=query(2*node+1,mid+1,r,le,ri);

     tree[1][node]=tree[1][2*node]+tree[1][2*node+1];
    tree[2][node]=tree[2][2*node]+tree[2][2*node+1];

    return r1+r2;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,q,z,l,r;
    cin>>n>>q;

    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        //dig[i]=finddig(a[i]);
    }
    build(1,1,n);

    for(long long i=1;i<=q;i++)
    {
        cin>>z>>l>>r;
        if(z==1)
        {
            update(1,1,n,l,r);
        }
        if(z==2)
        {
            cout<<query(1,1,n,l,r)<<endl;
        }
    }
}
/*
3 5
15 35 11
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
*/
