#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = (1 << 20), maxc = 60;

struct node
{
    vector < ll > sum_aft1;
    vector < ll > sum_aft2;
    ll type;

    node()
    {

    }
};

ll n, q;
ll a[maxn];
node tree[2 * maxn];
ll tag[2 * maxn], lazy[2 * maxn];


node merge_node(node nd1, node nd2, ll type)
{
    node nd;
    nd.type = type;
    if (type == 1)
        nd.sum_aft1.resize(maxc, 0);
    else
        nd.sum_aft2.resize(maxc, 0);
    if (nd1.type == 1)
    {
        if (type == 1)
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft1[i] += nd1.sum_aft1[i];
        }
        else
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft2[i] += nd1.sum_aft1[i];
        }
    }
    else
    {
        if (type == 1)
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft1[i] += nd1.sum_aft2[i];
        }
        else
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft2[i] += nd1.sum_aft2[i];
        }
    }

    if (nd2.type == 1)
    {
        if (type == 1)
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft1[i] += nd2.sum_aft1[i];
        }
        else
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft2[i] += nd2.sum_aft1[i];
        }
    }
    else
    {
        if (type == 1)
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft1[i] += nd2.sum_aft2[i];
        }
        else
        {
            for (ll i = 0; i < maxc; i ++)
                nd.sum_aft2[i] += nd2.sum_aft2[i];
        }
    }
    return nd;
}

ll count_digits(ll x)
{
    ll cnt = 0;
    do
    {
        cnt ++;
        x /= 10;
    }
    while(x != 0);
    return cnt;
}

void build_tree(ll root, ll left, ll right)
{
    if (left == right)
    {
        tree[root].sum_aft1.resize(maxc, 0);
        tree[root].type = 1;
        ll to = count_digits(a[left]), st = 1;
        for (ll i = 1; i < to; i ++)
            st *= 10;
        tree[root].sum_aft1[0] = a[left];
        for (ll i = 1; i < maxc; i ++)
        {
            tree[root].sum_aft1[i] = tree[root].sum_aft1[i - 1] / 10 + st * (tree[root].sum_aft1[i - 1] % 10);
        }
        return;
    }

    ll mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);
    ll type = 1;
    if (right - left >= 1e3)
        type = 2;
    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1], type);
}

ll help[maxc];
void push_lazy(ll root, ll left, ll right)
{
    lazy[root] %= maxc;
    if (lazy[root] == 0)
    {
        tag[root] = 0;
        return;
    }
    if (tree[root].type == 1)
    {
        for (ll i = 0; i < maxc; i ++)
            help[i] = tree[root].sum_aft1[i];

        for (ll i  = 0; i < maxc - lazy[root]; i ++)
            tree[root].sum_aft1[i] = tree[root].sum_aft1[i + lazy[root]];
        ll id = maxc - lazy[root];
        for (ll i = maxc - lazy[root]; i < maxc; i ++)
            tree[root].sum_aft1[i] = help[i - id];
    }
    else
    {
        for (ll i = 0; i < maxc; i ++)
            help[i] = tree[root].sum_aft2[i];

        for (ll i  = 0; i < maxc - lazy[root]; i ++)
            tree[root].sum_aft2[i] = tree[root].sum_aft2[i + lazy[root]];
        ll id = maxc - lazy[root];
        for (ll i = maxc - lazy[root]; i < maxc; i ++)
            tree[root].sum_aft2[i] = help[i - id];
    }
    if (left == right)
    {
        //cout << "HERE" << endl;
    }
    if (left != right)
    {
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
        tag[root * 2] = tag[root * 2 + 1] = 1;
    }

    lazy[root] = 0;
    tag[root] = 0;

}

void update_range(ll root, ll left, ll right, ll qleft, ll qright)
{
    ///if (tag[root])

    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return;
    if (left >= qleft && right <= qright)
    {
        lazy[root] ++;
        tag[root] = 1;
        push_lazy(root, left, right);
        return;
    }

    ll mid = (left + right) / 2;
    update_range(root * 2, left, mid, qleft, qright);
    update_range(root * 2 + 1, mid + 1, right, qleft, qright);

    ll type = 1;
    if (right - left >= 1e3)
        type = 2;
    tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1], type);
}

ll query(ll root, ll left, ll right, ll qleft, ll qright)
{
    //if (qleft && qright && qleft == 4)
    // cout << left << " " << right << " " << lazy[root] << endl;
    push_lazy(root, left, right);

    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
    {
        if (tree[root].type == 1)
            return tree[root].sum_aft1[0];
        return tree[root].sum_aft2[0];
    }

    ll mid = (left + right) / 2;
    return query(root * 2, left, mid, qleft, qright) +
           query(root * 2 + 1, mid + 1, right, qleft, qright);
}
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];

    build_tree(1, 1, n);
    //update_range(1, 1, n, 3, 6);
    //cout << query(1, 1, n, 4, 4) << endl;

    for (ll i = 1; i <= q; i ++)
    {
        ll type, l, r;
        cin >> type >> l >> r;
        if (type == 1)
        {
            update_range(1, 1, n, l, r);
        }
        else
        {
            ll ans = query(1, 1, n, l, r);
            cout << ans << endl;
        }


    }


}

int main()
{
    speed();
    solve();
    return 0;
}
/**
312
229
361
357
238
140
193
383
23
149
102
35
168
303
77
213
179
90
97
248
672
390
354
35
176
55
105
234
63
299
442
128
436
97
440
128
135
102
214
*/
