#include<iostream>
#include<set>
#include<vector>
using namespace std;

const int MAXX=3001, MOD=1e9+7;

multiset<int> st;
vector<pair<int, int> > v[MAXX];

long long GetGCD(int a, int b)
{
    if(b==0)
    {
        return a;
    }

    return GetGCD(b, a%b);
}

long long GetSum()
{
    vector<int> nums;
    for(int x:st)
    {
        nums.push_back(x);
    }

    long long sum=0;
    int n=nums.size();
    for(int i=1; i<(1<<n); i++)
    {
        int gcd=-1;
        for(int j=0; j<n; j++)
        {
            if(i&(1<<j))
            {
                if(gcd==-1)
                {
                    gcd=nums[j];
                }
                else
                {
                    gcd=GetGCD(gcd, nums[j]);
                }
            }
        }

        sum=(sum+gcd)%MOD;
    }

    return sum;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;

    if(n<=10 && q<=10)
    {
        for(int i=0; i<n; i++)
        {
            int x;
            cin >> x;

            st.insert(x);
        }

        cout << GetSum() << "\n";

        while(q--)
        {
            int t, x;
            cin >> t >> x;

            if(t==1)
            {
                st.insert(x);
            }
            else
            {
                st.erase(x);
            }

            cout << GetSum() << "\n";
        }
    }

    return 0;
}
