#include <iostream>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <stdio.h>
#include <math.h>

using namespace std;

int n,Q;
int nums[100010];
int digits[100010];
struct Node
{
	Node *l,*r;
	int from;
	int to;
	int val;
	int lp;	
	Node(int f,int t)
	{
		from=f;
		to=t;
		l=NULL;
		r=NULL;
	}
}*Root,*Leafs[100010];

void build(Node* node,int from,int to)
{
	if(from==to)
	{
		node->l=NULL;
		node->r=NULL;
		node->val=nums[from];
		Leafs[from]=node;
		return;
	}
	node->l=new Node(from,(from+to)/2);
	build(node->l,from,(from+to)/2);
	node->r=new Node((from+to)/2+1,to);
	build(node->r,(from+to)/2+1,to);
	node->val=node->l->val+node->r->val;
}

void Update(Node* node,int from,int to)
{
	if(node==NULL)return;
	if(node->to<from||node->from>to)return;
	if(node->from==node->to)
		node->val=(node->val%10)*digits[node->from]+node->val/10;
	else
	{
		Update(node->l,from,to);
		Update(node->r,from,to);
		node->val=node->l->val+node->r->val;
	}
}

long long getSum(Node* node,int from,int to)
{
	if(node==NULL)return 0;
	if(node->to<from||node->from>to)return 0;
	if(node->from==node->to)return node->val;
	else return getSum(node->l,from,to)+getSum(node->r,from,to);
}

void Print(Node* node,int depth)
{
	if(node==NULL)return;
	Print(node->l,depth+1);
	for(int i=0;i<depth;i++)cout<<"       ";
	cout<<node->val<<endl;
	Print(node->r,depth+1);
	
}

int main()
{
	int a,b,c;
	scanf("%d%d",&n,&Q);
	for(int i=0;i<n;i++)
		scanf("%d",&nums[i]);
	Root=new Node(0,n-1);
	build(Root,0,n-1);
	
	for(int i=0;i<n;i++)
		digits[i]=pow(10,floor(log10(nums[i]) ) );
//	for(int i=0;i<n;i++)
//		cout<<digits[i]<<"  ";
//		cout<<endl;
//	Update(Root,1,6);
//	Print(Root,0);
	for(int i=0;i<Q;i++)
	{
		scanf("%d%d%d",&a,&b,&c);
		if(a==1)Update(Root,b-1,c-1);
		else cout<<getSum(Root,b-1,c-1)<<endl;
	}
}
/*
8 3
123 2543 15678 28 53 348 4956 38987
*/
