#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MOD = 1000000007;
int q, n;
set<int> st;
int sum = 0;

int nod(int a, int b)
{
    int r;
    while (b)
    {
        r = a % b;
        a = b;
        b = r;
    }

    return a;
}

void init(set<int>::iterator idx, int gcd = 0)
{
    if (idx == st.end())
    {
        sum += gcd;
        sum %= MOD;
        return;
    }

    auto tmp = *idx;

    set<int>::iterator curr_idx = idx;
    idx++;
    init(idx, nod(tmp, gcd));

    init(idx, gcd);
}

int tmp_sum = 0;

void get(int x, set<int>::iterator idx, int gcd = 0)
{
    if (idx == st.end())
    {
        tmp_sum += nod(x, gcd);
        sum %= MOD;
        return;
    }

    //cout << "get: " << x << " " << *idx << endl;

    auto tmp = *idx;
    set<int>::iterator curr_idx = idx;
    idx++;
    get(x, idx, nod(tmp, gcd));
    get(x, idx, gcd);
}

void input()
{
    cin >> n >> q;
    for (int i = 0; i < n; ++i)
    {
        int x;
        cin >> x;
        st.insert(x);
    }
}

void solve()
{
    init(st.begin());
    cout << sum << endl;

    for (int test = 0; test < q; ++test)
    {
        int type, x;
        cin >> type >> x;
        tmp_sum = 0;

        if (type == 1)
        {
            get(x, st.begin());
            sum += tmp_sum;
            sum %= MOD;
            st.insert(x);
        }
        else if (type == 2)
        {
            st.erase(x);
            get(x, st.begin());
            sum -= tmp_sum;
            sum += MOD;
            sum %= MOD;

        }

        cout << sum << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();


    return 0;
}
