#include<bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;

ll segtr[(1<<21)];
int trsz=(1<<21);
int n,q;
ll a[1000001];
vector<ll> diff[1000001];
int state[1000001];

int leaf(int x)
{
    return x+trsz/2;
}
void upd(int l,int r)
{
    l=leaf(l);
    r=leaf(r);
    if(l==r){segtr[l]++; return ;}
    segtr[l]++;
    segtr[r]++;
    while((l/2)!=(r/2))
    {
        if(!(l&1)) segtr[l+1]++;
        if(r&1) segtr[r-1]++;
        l>>=1;
        r>>=1;
    }
}
ll query(int y)
{
    int x=leaf(y);
    ll sum=0;
    while(x)
    {
        sum+=segtr[x];
        x>>=1;
    }
    sum%=diff[y].size();
    ll ret=a[y];
    for(int i=0;i<sum;i++) ret+=diff[y][i];
    return ret;
}
ll rot(ll x)
{
    ll d=x%10;
    for(ll y=x/10;y;y/=10) d*=10;
    return d+x/10;
}
void gen_diff()
{
    for(int i=0;i<n;i++)
    {
        ll x=a[i],y=rot(a[i]);
        diff[i].pb(y-x);
        while(y!=a[i])
        {
            x=y;
            y=rot(x);
            diff[i].pb(y-x);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin>>n>>q;
    for(int i=0;i<n;i++){cin>>a[i]; }
    gen_diff();
    for(;q--;)
    {
        int t,l,r;
        cin>>t>>l>>r; l--; r--;
        if(t==1)
        {
            upd(l,r);
        }
        else
        {
            cout<<query(l)<<endl;
        }
    }
    return 0;
}
/**

3 6
15 35 112
2 1 2
2 1 3
1 2 2
2 2 3
1 3 3
2 1 3

3 6
15 35 112
1 1 3
2 3 3
1 2 3
2 3 3
2 2 2
2 1 1

*/
