#include<bits/stdc++.h>
#define ll long long
#define endl '\n'
using namespace std;
const ll MAX_N = 3002;
const ll MOD = 1e9+7;
ll table[MAX_N];
ll active = 0;
ll fast_pow(ll num, ll st)
{
    if(st == 0) return 1;
    ll half = fast_pow(num, st/2);
    if(st&1) return ((((half*half)%MOD)*num)%MOD);
    return (half*half)%MOD;
}
ll calc_table(ll br)
{
    if(br == 0) return 0;
    ll all = fast_pow(2,br)-1;
    ll res = 0;
    for(ll i=1; i<=3000; i++)
    {
        if(table[i])
        {
            ll sub_size = 0;
            for(ll j=i*2; j<=3000; j+=i)
            {
                sub_size += table[j];
            }
            ll tmp = fast_pow(2,sub_size);
            res+=((i*tmp)%MOD);
            res%=MOD;
            all-=tmp;
            if(all < 0) all+=MOD;
        }
    }
    res += all;
    return res;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n,q,c;
    set<ll> s;
    cin>>n>>q;
    active = n;
    for(ll i=0; i<n; i++)
    {
        cin>>c;
        table[c] = 1;
    }
    cout<<calc_table(active)<<endl;
    ll type0, num0;
    for(ll i=0; i<q; i++)
    {
        cin>>type0>>num0;
        if(type0 == 1)
        {
            table[num0] = 1;
            active++;
        }
        else
        {
            table[num0] = 0;
            active--;
        }
        cout<<calc_table(active)<<endl;
    }
}
