#include <bits/stdc++.h>
using namespace std;

const long long MAXN = 1e6+1;
long long a[MAXN];

struct Tel {
    long long l, r;
    Tel *ld, *rd;
    long long sum;
    bool lazy;
};

void Build(Tel* k){
    k->lazy = 0;
    long long tl = k->l, tr = k->r;
    if(tl == tr) {
        k->ld = NULL;
        k->rd = NULL;
        k->sum = a[tl];
        return;
    }
    k->ld = new Tel;
    k->ld->l = tl; k->ld->r = (tl+tr)/2;
    Build(k->ld);
    k->rd = new Tel;
    k->rd->l = (tl+tr)/2+1;  k->rd->r = tr;
    Build(k->rd);
    k->sum = k->ld->sum + k->rd->sum;
}

void Print(Tel* k) {
    cout<<(k->l)<<" "<<(k->r)<<"  "<<(k->sum)<<endl;
    if(k->l != k->r) {
        Print(k->ld);
        Print(k->rd);
    }
}

void Update(long long l, long long r, Tel* k) {
    long long tl = k->l, tr = k->r;
    if(tr < l || r < tl) return;

    if(l <= tl && tr <= r) {
        k->sum = a[l];
        return;
    }
    else {
        Update(l, r, k->ld);
        Update(l, r, k->rd);
        k->sum = k->ld->sum + k->rd->sum;
    }
}

long long Find(long long l, long long r, Tel* k) {
    long long tl = k->l, tr = k->r;
    if(tr < l || r < tl) return 0;
    if(l <= tl && tr <= r) {
        return k->sum;
    }
    else {
        return Find(l, r, k->ld) + Find(l, r, k->rd);
    }
}

int main()
{
    long long n, q;
    cin>>n>>q;
    long long i;
    for(i=1;i<=n;i++) cin>>a[i];

    Tel* root = new Tel;
    root->l = 1;  root->r = n;
    Build(root);
    //cout<<"Build"<<endl;

    //Prlong long(root);
    while(q--) {
        long long z, l, r;
        cin>>z>>l>>r;
        if(z == 1) {
            //change a[l]
            long long del = 1, k = a[l];
            while(k > 0) {
                del*=10;
                k/=10;
            }
            del/=10;
            a[l] = a[l]/10 + a[l]%10*del;
            //cout<<a[l]<<endl;
            Update(l, r, root);
        }
        else
        if(z == 2) {
            cout<<Find(l, r, root)<<endl;
        }
    }

    return 0;
}
