#include <bits/stdc++.h>
using namespace std;

long long tree[4*5000];
long long a[5001];
long long n, q;
long long  ql, qr, type;

void build(int l, int r, int v)
{
    int mid = l+r;
    mid/=2;
    if(l==r)
    {
        tree[v] = a[r];
    }
    else
    {
        build(l, mid, 2*v);
        build(mid+1, r, 2*v+1);
        tree[v] = tree[2*v]+tree[2*v+1];
    }
    return;
}
long long query(int l, int r, int v)
{
    if(ql>r||qr<l) return 0;
    if(ql<=l&&r<=qr) return tree[v];

    int mid = l+r;
    mid/=2;

    return query(l, mid, v*2) + query(mid+1, r, v*2+1);
}
void update(int l, int r, int v)
{
    if(l==r) return;
    int mid = l+r;
    mid/=2;
    update(l, mid, v*2);
    update(mid+1, r, 2*v+1);
    tree[v] = tree[v*2]+tree[2*v+1];
}
void query2(int l, int r, int v)
{
    if(ql>r||qr<l) return;
    if(ql<=l&&r<=qr&&l==r)
    {
        long long chislo = tree[v];
        long long chislo2 = chislo;
        int k = 1;
        while(chislo>0)
        {
            chislo/=10;
            k*=10;
        }
        tree[v] = (k*(chislo2%10) + (chislo2 - chislo2%10))/10;
        return;
    }
    int mid = l+r;
    mid/=2;
    query2(l, mid, v*2);
    query2(mid+1, r, v*2+1);
    update(1, n, 1);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>q;
    for(int i=1; i<=n; i++)
        cin>>a[i];
    build(1, n, 1);
    while(q--)
    {
        cin>>type>>ql>>qr;
        if(type==2) cout<<query(1, n, 1)<<endl;
        else query2(1, n, 1);
    }
    return 0;
}

