#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+5, maxa = 2e6+6, mod = 1e9+7;
int n, q;
long long d1 [maxa], d2 [maxa], sum;

bool notPrime [maxa];
vector <int> primes;
void findPrimes (){
    for (int i = 2; i < maxa; i ++){
        if (notPrime [i]) continue;
        primes.push_back (i);
        for (int j = i + i; j < maxa; j += i) notPrime [j] = 1;
    }
}

vector <pair <int, int> > divs, divs1;
void calcDivs (){
    int d = 1;
    for (auto p : divs1){
        for (int i = 0; i < p.second; i ++) d *= p.first;
    }
    d1 [d] = (d1 [d] + d2 [d]) % mod;
    sum += (long long) d * d2 [d];
    sum %= mod;
    for (auto p : divs1){
        int dd = d / p.first;
        d1 [dd] = (d1 [dd] + mod - d2 [d]) % mod;
        sum += mod - (long long) dd * d2 [d];
        sum %= mod;
    }
    d2 [d] = (d2 [d] * 2 + 1) % mod;
}
void cycleDivs (int pos){
    if (pos == divs.size ()){
        calcDivs ();
        return;
    }
    cycleDivs (pos + 1);
    divs1.push_back ({divs [pos].first, 1});
    int x = divs [pos].second;
    while (x --){
        cycleDivs (pos + 1);
        divs1.back ().second ++;
    }
    divs1.pop_back ();
}

void addNumber (int a){
    d1 [a] ++;
    sum += a;
    divs.clear ();
    divs1.clear ();
    for (int i : primes){
        if (a % i > 0) continue;
        divs.push_back ({i, 0});
        while (a % i == 0){
            divs.back ().second ++;
            a /= i;
        }
        if (a > 1 && !notPrime [a]){
            divs.push_back ({a, 1});
            a = 1;
        }
        if (a == 1) break;
    }
    cycleDivs (0);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    findPrimes ();

    cin >> n >> q;
    for (int i = 0; i < n; i ++){
        int a;
        cin >> a;
        addNumber (a);
    }
    cout << sum << '\n';
    while (q --){
        int t, a;
        cin >> t >> a;
        if (t == 1) addNumber (a);
        cout << sum << '\n';
    }

}
