#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int mod = 1e9 + 7;
const int maxn = 3003;

int add(int a, int b) {
    a += b;
    if (a >= mod)
        a -= mod;

    return a;
}

int n, q;
int cnt[maxn], cnt2[maxn];
void read() {
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;

        cnt[x]++;
    }
}

int p[maxn], c[maxn];
int pow2[maxn];

int get() {
    int ans = 0;
    for (int i = 1; i < maxn; i++)
        ans = add(ans, (long long)(pow2[cnt2[i]] - 1) * c[i] % mod);

    return ans;
}

void solve() {
     for (int i = maxn-1; i >= 1; i--) {
        cnt2[i] = 0;
        for (int j = i; j < maxn; j += i)
            cnt2[i] = add(cnt2[i], cnt[j]);
    }

    pow2[0] = 1;
    for (int i = 1; i < maxn; i++)
        pow2[i] = add(pow2[i-1], pow2[i-1]);

    for (int i = 2; i < maxn; i++)
        if (!p[i])
        for (int j = i; j < maxn; j += i)
        if (!p[j])
        p[j] = i;

    c[1] = 1;
    for (int i = 2; i < maxn; i++) {
        int left = i, deg = 1;
        while (left % p[i] == 0) {
            deg *= p[i];
            left /= p[i];
        }

        if (left == 1)
            c[i] = (p[i] - 1) * i / p[i];

        else
            c[i] = c[left] * c[deg];

        c[i] %= mod;
    }

    cout << get() << endl;
    while (q--) {
        int type, x;
        cin >> type >> x;

        if (type == 1)
            cnt[x]++;

        else
            cnt[x]--;

        for (int i = maxn-1; i >= 1; i--) {
        cnt2[i] = 0;
        for (int j = i; j < maxn; j += i)
            cnt2[i] = add(cnt2[i], cnt[j]);
        }

        cout << get() << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
