#include<iostream>
#include<vector>
using namespace std;

int broiChisla;
int broiZaqvki;

int chisla[1000010];

int broiCifri(int chi){
    int br = 0;

    while(chi > 0){
        chi /= 10;
        br++;
    }

    return br;
}

int rotateniChisloto(int chi){
    int poslCifra = chi%10;
    chi /= 10;

    int brCifr = broiCifri(chi);

    int desetNaStepenta = 1;

    for(int i = 0; i < brCifr; i++){
        desetNaStepenta *= 10;
    }

    chi = poslCifra*desetNaStepenta + chi;

    return chi;
}

struct DanniZaVarha{
    int stoinost;
    int otKadeObhvashta;
    int doKadeObhvashta;
    int lqvoDete;
    int dqsnoDete;
};

vector<DanniZaVarha> varhove;
int korenNomer = -1;

int daiNovVrah(DanniZaVarha novVrah){
    varhove.push_back(novVrah);
    return varhove.size() - 1;
}

int napraviDarvo(int otKade, int doKade){
    if(otKade == doKade){
        return daiNovVrah({chisla[otKade], otKade, doKade, -1, -1});
    }

    int lqvoDete = napraviDarvo(otKade, (otKade + doKade)/2);
    int dqsnoDete = napraviDarvo((otKade + doKade)/2 + 1, doKade);

    return daiNovVrah({varhove[lqvoDete].stoinost + varhove[dqsnoDete].stoinost, otKade, doKade, lqvoDete, dqsnoDete});

}

vector<int> otgovori;

int main(){

    cin>>broiChisla>>broiZaqvki;

    for(int i = 0; i < broiChisla; i++){
        cin>>chisla[i];
    }

    if(broiChisla <= 5000 && broiZaqvki <= 5000){
        for(int i = 0; i < broiZaqvki; i++){
            int tip;
            int otKade;
            int doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;

            if(tip == 1){
                for(int j = otKade; j <= doKade; j++){
                    chisla[j] = rotateniChisloto(chisla[j]);
                }
            }else{
                int suma = 0;
                for(int j = otKade; j <= doKade; j++){
                    suma += chisla[j];
                }

                otgovori.push_back(suma);
            }
        }
    }else{
        for(int i = 0; i < broiZaqvki; i++){
            int tip;
            int otKade;
            int doKade;
            cin>>tip>>otKade>>doKade;

            otKade--;
            doKade--;
        }
    }

    for(int i = 0; i < (int)otgovori.size(); i++){
        cout<<otgovori[i]<<endl;
    }

    return 0;
}
