#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

long long const MAXN=2000001;
long long n, q, a[MAXN], tree[4*MAXN];

void make_tree(long long idx, long long l, long long r)
{
    if(l == r)
    {
        tree[idx] = a[l];
        return;
    }
    long long mid = (l+r)/2;
    make_tree(idx*2, l, mid);
    make_tree(idx*2+1, mid+1, r);
    tree[idx] = tree[idx*2] + tree[idx*2+1];
}

void update(long long idx, long long l, long long r, long long pos)
{
    if(l == r)
    {
        long long d = tree[idx]/10;
        long long ost = tree[idx] % 10;
        while(d > 0)
        {
            ost*=10;
            d/=10;
        }
        tree[idx] = ost + (tree[idx]/10);
        //cout<<tree[idx]<<endl;
        return;
    }
    long long mid = (l+r)/2;
    if(pos <= mid) update(idx*2, l, mid, pos);
    else update(idx*2+1, mid+1, r, pos);
    tree[idx] = tree[idx*2] + tree[idx*2+1];
}

long long query(long long idx, long long l, long long r, long long ql, long long qr)
{
    if(l > r || ql > r || qr < l) return 0;
    if(ql <= l && qr >= r)
    {
        return tree[idx];
    }
    long long mid = (l+r)/2;
    return query(idx*2, l, mid, ql, qr) + query(idx*2+1, mid+1, r, ql, qr);
}

void read()
{
    long long type, l, r;
    cin>>n>>q;
    for(long long i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    make_tree(1,1,n);
    for(long long i=1; i<=q; i++)
    {
        cin>>type>>l>>r;
        if(type == 1)
        {
            for(long long i=l;i<=r;i++)
            {
                update(1,1,n,i);
            }
        }
        else
        {
            cout<<query(1,1,n,l,r)<<endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
