#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

long long const MAXN=2000001;
long long n, q, a[MAXN], lazy[4*MAXN];

void push_lazy(long long idx, long long l, long long r)
{
    if(lazy[idx] != 0)
    {
        if(l != r)
        {
            lazy[idx*2] += lazy[idx];
            lazy[idx*2+1] += lazy[idx];
            lazy[idx] = 0;
        }
    }
}

void update(long long idx, long long l, long long r, long long ql, long long qr)
{
    push_lazy(idx, l, r);
    if(l > r || ql > r || qr < l) return;
    if(ql <= l && qr >= r)
    {
        lazy[idx] ++;
        push_lazy(idx, l, r);
        return;
    }
    long long mid = (l+r)/2;
    update(idx*2, l, mid, ql, qr);
    update(idx*2+1, mid+1, r, ql, qr);
}

long long query(long long idx, long long l, long long r, long long pos)
{
    push_lazy(idx, l, r);
    if(l == r)
    {
        return lazy[idx];
    }
    long long mid = (l+r)/2;
    if(pos <= mid) return query(idx*2, l, mid, pos);
    else return query(idx*2+1, mid+1, r, pos);
}

void read()
{
    long long type, l, r;
    cin>>n>>q;
    for(long long i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    for(long long i=1; i<=q; i++)
    {
        cin>>type>>l>>r;
        if(type == 1)
        {
            update(1,1,n,l,r);
        }
        else
        {
            long long len = query(1,1,n,r);
            long long d = a[r], cnt=0, st=1;
            while(d>0)
            {
                d/=10;
                st*=10;
                cnt++;
            }
            len = len%cnt;
            d = 1;
            while(len>0)
            {
                d*=10;
                len--;
            }
            st/=10;
            long long ost = a[r] % d;
            cout<<ost * st + (a[r] / d)<<endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
