#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn = 100000;
struct node
{
    long long suma;
    vector<long long>gcd;
    node()
    {
        suma = 0;
        gcd.clear();
    }
};
long long n,q;
long long a[maxn];
node tree[maxn*4];
map<long long,long long>mp;
map<long long,long long>idx;
map<long long,long long>is_active;
long long cnt = 1;
long long mod = 1000000007;
vector< pair<long long,long long> >v;
void make_tree( long long i, long long l, long long r )
{
    if( l == r )
    {
        if( is_active[l] == 2 ) return;
        tree[i].suma = idx[l];
        tree[i].gcd.push_back(idx[l]);
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    long long sz_1 = tree[i*2].gcd.size();
    long long sz_2 = tree[i*2+1].gcd.size();
    tree[i].suma = tree[i*2].suma + tree[i*2+1].suma;
    tree[i].suma %= mod;
    tree[i].gcd.clear();
    for( long long k = 0; k < sz_1; k ++ )
    {
        for( long long j = 0; j < sz_2; j ++ )
        {
            long long x = tree[i*2].gcd[k];
            long long y = tree[i*2+1].gcd[j];
            long long t = __gcd(x,y);
            tree[i].gcd.push_back(t);
            tree[i].suma += t;
            tree[i].suma %= mod;
        }
    }

    for( long long j = 0; j < sz_1; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2].gcd[j] );
    }
    for( long long j = 0; j < sz_2; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2+1].gcd[j] );
    }
}
void update_2( long long i, long long l, long long r, long long pos  )
{
    if( l == r )
    {
        //cout << idx[l] << endl;
        tree[i].suma = 0;
        tree[i].gcd.clear();
        return;
    }
    long long m = ( l + r )/ 2;
    if( pos <= m ) update_2(i*2,l,m,pos);
    else update_2(i*2+1,m+1,r,pos);

    long long sz_1 = tree[i*2].gcd.size();
    long long sz_2 = tree[i*2+1].gcd.size();
    tree[i].gcd.clear();
    tree[i].suma = tree[i*2].suma + tree[i*2+1].suma;
    tree[i].suma %= mod;
    for( long long k = 0; k < sz_1; k ++ )
    {
        for( long long j = 0; j < sz_2; j ++ )
        {
            long long x = tree[i*2].gcd[k];
            long long y = tree[i*2+1].gcd[j];
            long long t = __gcd(x,y);
            tree[i].gcd.push_back(t);
            tree[i].suma += t;
            tree[i].suma %= mod;
        }
    }

    for( long long j = 0; j < sz_1; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2].gcd[j] );
    }
    for( long long j = 0; j < sz_2; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2+1].gcd[j] );
    }
    return;
}
void update_1( long long i, long long l, long long r, long long pos )
{
    if( l == r )
    {
        //cout << idx[l] << endl;
        tree[i].suma = idx[l];
        tree[i].gcd.push_back(idx[l]);;
        return;
    }
    long long m = ( l + r )/ 2;
    if( pos <= m ) update_1(i*2,l,m,pos);
    else update_1(i*2+1,m+1,r,pos);

    long long sz_1 = tree[i*2].gcd.size();
    long long sz_2 = tree[i*2+1].gcd.size();
    tree[i].gcd.clear();
    tree[i].suma = tree[i*2].suma + tree[i*2+1].suma;
    tree[i].suma %= mod;
    for( long long k = 0; k < sz_1; k ++ )
    {
        for( long long j = 0; j < sz_2; j ++ )
        {
            long long x = tree[i*2].gcd[k];
            long long y = tree[i*2+1].gcd[j];
            long long t = __gcd(x,y);
            tree[i].gcd.push_back(t);
            tree[i].suma += t;
            tree[i].suma %= mod;
        }
    }

    for( long long j = 0; j < sz_1; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2].gcd[j] );
    }
    for( long long j = 0; j < sz_2; j ++ )
    {
        tree[i].gcd.push_back( tree[i*2+1].gcd[j] );
    }
    return;
}
void read()
{
    cin >> n >> q;
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> a[i];
        if( mp[a[i]] == 0 )
        {
            mp[a[i]] = cnt;
            idx[cnt] = a[i];
            is_active[cnt] = 1;
            cnt += 1;
        }
    }
    for( long long i = 1; i <= q; i ++ )
    {
        long long t,x;
        cin >> t >> x;
        if( mp[x] == 0 )
        {
            mp[x] = cnt;
            idx[cnt] = x;
            is_active[cnt] = 2;
            cnt += 1;
        }
        pair<long long,long long>p(t,x);
        v.push_back(p);
    }
}
int main()
{
    read();
    make_tree(1,1,cnt-1);
    cout << tree[1].suma << endl;
    for( long long i = 0; i < q; i ++ )
    {
        long long t = v[i].first;
        long long x = v[i].second;
        //cout << t << " " << x << endl;
        if( t == 1 )
        {
            //cout << t << " " << x << endl;
            update_1(1,1,cnt-1,mp[x]);
            cout << tree[1].suma << endl;
        }
        else
        {
            update_2(1,1,cnt-1,mp[x]);
            cout << tree[1].suma << endl;
        }
        //cout << endl;
    }
    return 0;
}
