#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int maxn = 1000001;
int n,q;
int a[maxn];
int tree[maxn*4];
int lazy[maxn*4];
int pw[128];
void make_tree(int i, int l, int r)
{
    if( l == r )
    {
        tree[i] = a[l];
        return;
    }
    int m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i] = tree[i*2] + tree[i*2+1];
    return;
}
void push_lazy(int i, int l, int r )
{
    if( l == r ) return;
    lazy[i*2] += lazy[i];
    lazy[i*2+1] += lazy[i];
    lazy[i] = 0;
    return;
}
void update( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr )
    {
        lazy[i] += 1;
        push_lazy(i,l,r);
        return;
    }
    int m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr);
    else
    {
        update(i*2,l,m,ql,m);
        update(i*2+1,m+1,r,m+1,qr);
    }
    return;
}
int get_num( int x )
{
    if( x < 10 ) return 1;
    int cnt = 0;
    while( x != 0 )
    {
        cnt += 1;
        x /= 10;
    }
    return cnt;
}
int rot_x( int x, int cnt )
{
    int cnt_num = get_num(x);
    int ans = x;
    while( cnt != 0 )
    {
        cnt -= 1;
        int t1 = ans % 10;
        int t2 = ans / 10;
        t1 *= pw[cnt_num];
        t1 += t2;
        ans = t1;
    }
    return ans;
}
int query( int i, int l, int r, int pos )
{
    push_lazy(i,l,r);
    if( l == r )
    {
        int cnt_rot = lazy[i];
        lazy[i] = 0;
        a[l] = rot_x( a[l] , cnt_rot );
        return a[l];
    }
    int m = ( l + r ) / 2;
    if( pos <= m ) return query(i*2,l,m,pos);
    else return query(i*2+1,m+1,r,pos);
}
void read()
{
    cin >> n >> q;
    for( int i = 1; i <= n; i ++ )
    {
        cin >> a[i];
    }
    for( int i = 1; i <= q; i ++ )
    {
        int t,l,r;
        cin >> t >> l >> r;
        if( t == 1 )
        {
            update(1,1,n,l,r);
            continue;
        }
        else
        {
            cout << query(1,1,n,l) << endl;
        }
    }
}
int main()
{
    pw[1] = 1;
    for( int i = 2; i <= 6; i ++ )
    {
        pw[i] = pw[i-1] * 10;
    }
    read();
    return 0;
}
