#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
set<int> s;

void read() {
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;

        s.emplace(a);
    }
}

int fastPow(int a, int b) {
    int answer = 1;
    while (b) {
        if (b & 1) {
            answer = (1ll * answer * a) % MOD;
        }

        a = (1ll * a * a) % MOD;
        b >>= 1;
    }

    return answer;
}

int query() {
    int total = 0, mx = *s.rbegin();
    int all = (fastPow(2, s.size()) - 1 + MOD) % MOD;
    for (auto i = s.begin(); i != s.end(); i++) {
        long long num = 2 * (*i);
        int cnt = 0;
        while (num <= mx) {
            if (s.count(num)) {
                cnt++;
            }

            num += (*i);
        }

        int add = (1ll * (*i) * fastPow(2, cnt)) % MOD;
        total += add;
        if (total >= MOD) {
            total -= MOD;
        }

        all = (all - fastPow(2, cnt)) % MOD;
    }

    total += all;
    if (total >= MOD) {
        total -= MOD;
    }

    return total;
}

void solve() {
    cout << query() << endl;

    while (q--) {
        int type, x;
        cin >> type >> x;

        if (type == 1) {
            s.emplace(x);
        } else {
            s.erase(x);
        }

        cout << query() << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}
