#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n, q;
set<int> s;

void read() {
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;

        s.emplace(a);
    }
}

int query() {
    int total = 0, sz = s.size();
    for (int mask = 1; mask < (1 << sz); mask++) {
        int g = 0, pos = 0;
        for (int i : s) {
            if ((mask >> pos) & 1) {
                g = __gcd(g, i);
            }

            pos++;
        }

        total += g;
        if (total >= MOD) {
            total -= MOD;
        }
    }

    return total;
}

void solve() {
    cout << query() << endl;

    while (q--) {
        int type, x;
        cin >> type >> x;

        if (type == 1) {
            s.emplace(x);
        } else {
            s.erase(x);
        }

        cout << query() << endl;
    }
}

int main() {
    setIO();

    read();

    solve();
}
