# include <bits/stdc++.h>
using namespace std;
const int maxn = 8e6+5;
int a[maxn];
struct Segment
{
    int segm[maxn][6][6];
    int lazy[maxn];
    void build(int v, int from,int to)
    {
        if(from==to)
        {

            int x = a[from];
            int nums = 0;
            while(x!=0)
            {
                x/=10;
                nums++;
            }
            x = a[from];
            int i=0;
            while(x!=0)
            {
             //   cout<<from<<" : "<<nums-1<<" "<<i<<" :: "<<x%10<<endl;
                segm[v][nums-1][i]=x%10;
                i++;
                x/=10;
            }
            return ;
        }
        int mid = (from+to)/2;
        build(2*v,from,mid);
        build(2*v+1,mid+1,to);
        for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
        }
    }
    void update_lazy(int v, int from, int to)
    {
        if(lazy[v]==0)return ;
        if(from!=to){
        lazy[2*v] +=lazy[v];
        lazy[2*v+1] +=lazy[v];}
        while(lazy[v])
        {
            lazy[v]--;
            int i,j,prev;
            for(i =0;i<6;i++)
            {
                prev = segm[v][i][0];
                for(j = 0;j<i;j++)
                {
                    segm[v][i][j] = segm[v][i][j+1];
                }
                segm[v][i][i] = prev;
            }
        }
    }
    void update(int v, int from, int to, int l, int r)
    {
     update_lazy(v,from,to);
        if(l<=from&&to<=r)
        {
           lazy[v]++;
           update_lazy(v,from,to);
            return ;
        }
        int mid = (from+to)/2;
        update_lazy(2*v,from,mid);
        update_lazy(2*v+1,mid+1,to);
        if(l<=mid)update(2*v,from,mid,l,r);
        if(r>mid)
            update(2*v+1,mid+1,to,l,r);
         for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
        }
        return ;
    }
    long long query(int v, int from, int to, int l, int r)
    {
        update_lazy(v,from,to);
        long long ans = 0,i,j;
        if(l<=from&&to<=r)
        {
            for(i=0;i<6;i++)
            {
                long long pow = 1;
                for(j=0;j<6;j++)
                {
                    ans = (ans + (long long)segm[v][i][j]*pow);
                    pow*=10;
                }
            }
            return ans;
        }
        int mid = (from+to)/2;
        update_lazy(2*v,from,mid);
        update_lazy(2*v+1,mid+1,to);
        if(l<=mid)ans+=query(2*v,from,mid,l,r);
        if(r>mid)ans+=query(2*v+1,mid+1,to,l,r);
          for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
        }
        return ans;
    }
};
Segment S;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin>>n>>q;
    int i;
    for(i = 1;i<=n;i++)
    {
        cin>>a[i];
    }
    S.build(1,1,n);
    int type,l,r;
    for(i=1;i<=q;i++)
    {
        cin>>type>>l>>r;
        if(type==1)
        {
            S.update(1,1,n,l,r);
        }
        else
        {
            long long ans = S.query(1,1,n,l,r);
            cout<<ans<<endl;
        }
    }
}
