# include <bits/stdc++.h>
using namespace std;
const int maxn = 8e6+5;
int a[maxn];
struct Segment
{
    int segm[maxn][6][6];
    bool fl[maxn][6];
    int lazy[maxn];
    int sumlazy[maxn];
    void build(int v, int from,int to)
    {
        if(from==to)
        {
            sumlazy[v] = 0;
            int x = a[from];
            int nums = 0;
            while(x!=0)
            {
                x/=10;
                nums++;
            }
            x = a[from];
            int i=0;
            while(x!=0)
            {
             //   cout<<from<<" : "<<nums-1<<" "<<i<<" :: "<<x%10<<endl;
                segm[v][nums-1][i]=x%10;
                i++;
                x/=10;
            }
            fl[v][nums-1] = 1;
            return ;
        }
        int mid = (from+to)/2;
        build(2*v,from,mid);
        build(2*v+1,mid+1,to);
        for(int i = 0;i<6;i++)
        {
            for(int j  = 0;j<6;j++)
                segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
            fl[v][i] = (fl[2*v][i]|fl[2*v+1][i]);
        }
    }
    void update_lazy(int v, int from, int to)
    {
        if(lazy[v]==0)return ;
        if(from!=to){
        lazy[2*v] +=lazy[v];
        lazy[2*v+1] +=lazy[v];}
       sumlazy[v]+=lazy[v];
       lazy[v] = 0;
        return ;
    }
    void update(int v, int from, int to, int l, int r)
    {
     update_lazy(v,from,to);
        if(l<=from&&to<=r)
        {
           lazy[v]++;
           update_lazy(v,from,to);
            return ;
        }
        int mid = (from+to)/2;
        update_lazy(2*v,from,mid);
        update_lazy(2*v+1,mid+1,to);
        if(l<=mid)update(2*v,from,mid,l,r);
        if(r>mid)
            update(2*v+1,mid+1,to,l,r);
            int per1 = sumlazy[2*v];
            int per2 = sumlazy[2*v+1];
         for(int i = 0;i<6;i++)
        {
            if(!fl[v][i])continue;
            for(int j  = 0;j<=i;j++)
            {
                segm[v][i][j] = segm[2*v][i][(j+per1)%(i+1)] + segm[2*v+1][i][(j+per2)%(i+1)];
                 //segm[v][i][j] = segm[2*v][i][j]+segm[2*v+1][i][j];
            }

        }
        sumlazy[v] = 0;
        return ;
    }
    long long query(int v, int from, int to, int l, int r)
    {
        update_lazy(v,from,to);
        long long ans = 0,i,j;
        if(l<=from&&to<=r)
        {
            int x = sumlazy[v];
           // cout<<v<<" "<<from<<" "<<to<<" "<<l<<" "<<r<<" "<<x<<endl;
            for(i=0;i<6;i++)
            {
                if(!fl[v][i])continue;
                long long pow = 1;

                for(j=0;j<=i;j++)
                {
                  //  cout<<i+1<<" "<<j<<endl;
                    ans = (ans + (long long)segm[v][i][(j+x)%(i+1)]*pow);
                    pow*=10;
                }
            }
            return ans;
        }
        int mid = (from+to)/2;
        update_lazy(2*v,from,mid);
        update_lazy(2*v+1,mid+1,to);
        if(l<=mid)ans+=query(2*v,from,mid,l,r);
        if(r>mid)ans+=query(2*v+1,mid+1,to,l,r);
        return ans;
    }
};
Segment S;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,q;
    cin>>n>>q;
    int i;
    for(i = 1;i<=n;i++)
    {
        cin>>a[i];
    }
    S.build(1,1,n);
    int type,l,r;
    for(i=1;i<=q;i++)
    {
        cin>>type>>l>>r;
        if(type==1)
        {
            S.update(1,1,n,l,r);
        }
        else
        {
            long long ans = S.query(1,1,n,l,r);
            cout<<ans<<endl;
        }
    }
}
