#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=2e5+6;
const int MAXA=2e6+6;
const ll mod=1e9+7;
int cnt_this[MAXA];
ll cnt_nods[MAXN];
vector<int>divs[MAXA];
bool used[MAXA];
ll cnt[MAXN];
ll cnt_real[MAXN];
ll inv2;
ll fastpow(ll x,ll p)
{
    if(p==1)return x;
    if(p==0)return 1;
    ll t=fastpow(x,p/2);
    t*=t;t%=mod;
    if(p%2==1)
    {
        t*=x;
        t%=mod;
    }
    return t;
}
void precompute()
{
    for(int i=1;i<MAXA;++i)
    {
        for(int j=i;j<MAXA;j+=i)
        {
            divs[j].push_back(i);
        }
        reverse(divs[i].begin(),divs[i].end());
    }
}
int a[MAXN];
int n,q;
ll ans=0;
vector<pair<int,int> >queries;
void add(ll x)
{
    for(auto xd:divs[x])
    {
        ans+=mod-(cnt_real[xd]*xd)%mod;
        ans%=mod;
    }
    reverse(divs[x].begin(),divs[x].end());

    for(auto xd:divs[x])
    {
        cnt_real[xd]+=(mod-fastpow(2,cnt[xd])+1ll)%mod;
        for(auto dx:divs[x/xd])
        {
            int t=xd,t1=xd*dx;
            if(t1!=t)cnt_real[t]+=cnt_real[t1];
            else;
            cnt_real[t]%=mod;
        }
    }
    for(auto xd:divs[x])cnt[xd]++;

    /*for(int i=0;i<MAXA;i++)
    {
        if(cnt_real[i]!=0)
        {
            cout<<i<<" "<<cnt_real[i]<<endl;
        }
    }*/
    reverse(divs[x].begin(),divs[x].end());
    //reverse(divs[x].begin(),divs[x].end());
    for(auto xd:divs[x])
    {
        //cout<<"^ "<<xd<<endl;
        cnt_real[xd]+=(fastpow(2,cnt[xd])+mod-1)%mod;
        for(auto dx:divs[x/xd])
        {
            int t=xd,t1=xd*dx;
            if(t1!=t)cnt_real[t]+=mod-cnt_real[t1];
            else;
            cnt_real[t]%=mod;
        }
    }

    for(auto xd:divs[x])
    {
        ans+=(cnt_real[xd]*xd)%mod;
        ans%=mod;
    }
    //reverse(divs[x].begin(),divs[x].end());

    /*for(int i=0;i<MAXA;i++)
    {
        if(cnt_real[i]!=0)
        {
            cout<<i<<" "<<cnt_real[i]<<endl;
        }
    }*/

}
void rmv(ll x)
{

    for(auto xd:divs[x])
    {
        ans+=mod-(cnt_real[xd]*xd)%mod;
        ans%=mod;
    }
    reverse(divs[x].begin(),divs[x].end());

    for(auto xd:divs[x])
    {
        cnt_real[xd]+=(mod-fastpow(2,cnt[xd])+1ll)%mod;
        for(auto dx:divs[x/xd])
        {
            int t=xd,t1=xd*dx;
            if(t1!=t)cnt_real[t]+=cnt_real[t1];
            else;
            cnt_real[t]%=mod;
        }
    }
    for(auto xd:divs[x])cnt[xd]--;

    /*for(int i=0;i<MAXA;i++)
    {
        if(cnt_real[i]!=0)
        {
            cout<<i<<" "<<cnt_real[i]<<endl;
        }
    }*/
    reverse(divs[x].begin(),divs[x].end());
    //reverse(divs[x].begin(),divs[x].end());
    for(auto xd:divs[x])
    {
        //cout<<"^ "<<xd<<endl;
        cnt_real[xd]+=(fastpow(2,cnt[xd])+mod-1)%mod;
        for(auto dx:divs[x/xd])
        {
            int t=xd,t1=xd*dx;
            if(t1!=t)cnt_real[t]+=mod-cnt_real[t1];
            else;
            cnt_real[t]%=mod;
        }
    }

    for(auto xd:divs[x])
    {
        ans+=(cnt_real[xd]*xd)%mod;
        ans%=mod;
    }
    //reverse(divs[x].begin(),divs[x].end());

    /*for(int i=0;i<MAXA;i++)
    {
        if(cnt_real[i]!=0)
        {
            cout<<i<<" "<<cnt_real[i]<<endl;
        }
    }*/
}
int main()
{
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        used[a[i]]=1;
    }
    for(int i=0;i<q;i++)
    {
        int t,x;
        cin>>t>>x;
        used[x]=1;
        queries.push_back({t,x});
    }
    precompute();
    inv2=fastpow(2,mod-2);
    for(int i=1;i<=n;i++)add(a[i]);
    cout<<ans<<endl;
    /*for(int i=0;i<MAXA;i++)
    {
        if(cnt_real[i]!=0)
        {
            cout<<i<<" "<<cnt_real[i]<<endl;
        }
    }*/
    for(int i=0;i<q;i++)
    {
        if(queries[i].first==1)
        {
            add(queries[i].second);
        }
        else
        {
            rmv(queries[i].second);
        }
        cout<<ans<<endl;
    }
return 0;
}
