#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, q;
long long a[1000004];

int po[4000004];
int lazy[4000004];
long long segm[4000004][6][6];

void build_segm(int v, int le, int ri)
{
    if(le==ri)
    {
        int t=10, br=1;
        while(t<=a[le])
        {
            t*=10;
            br++;
        }
        segm[v][br-1][0]=a[le];
        for(int i=1; i<br; i++)
        {
            a[le]=a[le]/10+(a[le]%10)*(t/10);
            segm[v][br-1][i]=a[le];
        }
    }
    else
    {
        int mid=(le+ri)/2;
        build_segm(2*v, le, mid);
        build_segm(2*v+1, mid+1, ri);
        for(int i=0; i<6; i++)
        {
            for(int j=0; j<=i; j++) segm[v][i][j]=segm[2*v][i][j]+segm[2*v+1][i][j];
        }
    }
}

void push_lazy(int v, int le, int ri)
{
    po[v]+=lazy[v];
    po[v]%=60;
    if(le!=ri)
    {
        lazy[2*v]+=lazy[v];
        lazy[2*v+1]+=lazy[v];
        lazy[2*v]%=60;
        lazy[2*v+1]%=60;
    }
    lazy[v]=0;
}

void update(int v, int le, int ri, int be, int en)
{
    push_lazy(v, le, ri);
    if(le>en || ri<be) return;
    if(be<=le && ri<=en)
    {
        lazy[v]++;
        push_lazy(v, le, ri);
        return;
    }
    int mid=(le+ri)/2;
    update(2*v, le, mid, be, en);
    update(2*v+1, mid+1, ri, be, en);

    /**
    int i1=po[2*v], i2=po[2*v+1];
    for(int i=0; i<60; i++)
    {
        segm[v][i]=segm[2*v][i1]+segm[2*v+1][i2];
        i1++;
        i2++;
        if(i1==60) i1=0;
        if(i2==60) i2=0;
    }*/
    po[v]=0;
    int i1=po[2*v], i2=po[2*v+1];
    for(int i=0; i<6; i++)
    {
        for(int j=0; j<=i; j++)
        {
            segm[v][i][j]=segm[2*v][i][(i1+j)%(i+1)]+segm[2*v+1][i][(i2+j)%(i+1)];
        }
    }
}

long long query(int v, int le, int ri, int be, int en)
{
    push_lazy(v, le, ri);
    if(le>en || ri<be) return 0;
    if(be<=le && ri<=en)
    {
        long long sum=0;
        for(int i=0; i<6; i++)
        {
            sum+=segm[v][i][po[v]%(i+1)];
        }
        return sum;
    }
    int mid=(le+ri)/2;
    long long q1=query(2*v, le, mid, be, en);
    long long q2=query(2*v+1, mid+1, ri, be, en);
    return q1+q2;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

   /// cout<<0%1<<endl;
    cin>>n>>q;
    for(int i=0; i<n; i++) cin>>a[i];
    build_segm(1, 0, n-1);
    for(int i=0; i<q; i++)
    {
        int t, be, en;
        cin>>t>>be>>en;
        be--;
        en--;
        if(t==1) update(1, 0, n-1, be, en);
        else cout<<query(1, 0, n-1, be, en)<<endl;
    }
    return 0;
}
/**
3 20
16 36 112
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3

60
279
246
86
226
166
60
180
147
86
316
246

60
279
246
86
226
166
60
180
147
86
316
246
*/
