#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int MOD = 1000000007;

int n;
int a[MAXN + 5];

long long calc()
{
    long long ret = 0;
    for (int mask = 1; mask < (1ll << n); ++ mask)
    {
        long long g = 0;
        for (int i = 0; i < n; ++ i)
        {
            if ((mask & (1ll << i))) g = __gcd(g, 1ll * a[i]);
        }
        ret = (ret + g) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int q;
    cin >> n >> q;

    for (int i = 0; i < n; ++ i)
    {
        cin >> a[i];
    }

    cout << calc() << endl;

    for (int i = 1; i <= q; ++ i)
    {
        int t, x;
        cin >> t >> x;

        if (t == 1)
        {
            a[n] = x;
            n++;
        }
        else
        {
            for (int i = 0; i < n; ++ i)
            {
                if (a[i] == x)
                {
                    swap(a[i], a[n - 1]);
                    break;
                }
            }
            n--;
        }

        cout << calc() << endl;
    }

    return 0;
}
