#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int MAXA = 2000000;
const int MOD = 1e9 + 7;

int a[MAXN + 5], b[MAXA + 5], c[MAXA + 5];
long long d[MAXA + 5], pw[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        b[a[i]]++;
    }

    pw[0] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        pw[i] = (pw[i - 1] * 2) % MOD;
    }

    int k = 0;
    long long sum = 0;
    for (int i = MAXA; i >= 1; -- i)
    {
        long long t = 0;
        for (int j = i; j <= MAXA; j += i)
        {
            k++;
            c[i] += b[j];
            t = (t + d[j]) % MOD;
        }
        d[i] = (pw[c[i]] - 1 - t) % MOD;
        d[i] = (d[i] + MOD) % MOD;
        sum = (sum + (1ll * i * d[i]) % MOD) % MOD;
    }

    cout << sum << endl;

    return 0;
}
