#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const int maxc=3007;

int n,q,type;
int a[MAXN],last[maxc];
long long cnt[maxc],temp[maxc],ans,power;

const long long mod=1000000007;

vector< pair<int,int> > v;
vector<int> tree[4*MAXN];

void add(int x){
    for(int i=1;i<=maxc;i++){
        temp[i]=0;
    }
    for(int i=1;i<=maxc;i++){
        temp[__gcd(i,x)]+=cnt[i];
        temp[__gcd(i,x)]%=mod;
    }
    for(int i=1;i<=maxc;i++){
        v.push_back({i,cnt[i]});
        cnt[i]+=temp[i];
        if(i==x)cnt[i]++;
        cnt[i]%=mod;
    }
}

void calc(){
    ans=0;
    for(int i=1;i<=maxc;i++){
        ans+=cnt[i]*i;
        ans%=mod;
    }
}

void undoadd(){
    for(int i=int(v.size())-1;i>=int(v.size())-maxc;i--){
        cnt[v[i].first]=v[i].second;
    }
    if(int(v.size())<maxc)return 0;
    
    if(int(v.size())==maxc)v.clear();
    else{
        for(int i=0;i<maxc;i++)v.pop_back();
    }
}

void update(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[v].push_back(val);
    }else{
        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,val);
    }
}

void dfs(int v,int l,int r){
    for(int i=0;i<tree[v].size();i++)add(tree[v][i]);

    if(l==r){
        calc();
        cout<<ans<<"\n";
    }else{
        int tt=(l+r)/2;
        dfs(2*v,l,tt);
        dfs(2*v+1,tt+1,r);
    }

    for(int i=0;i<tree[v].size();i++)undoadd();
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>a[i];
        last[a[i]]=1;
    }

    for(int i=2;i<=q+1;i++){
        cin>>type>>a[0];
        if(type==1)last[a[0]]=i;
        else {update(1,1,q+1,last[a[0]],i-1,a[0]); last[a[0]]=0;}
    }

    for(int i=1;i<=maxc;i++){
        if(last[i]!=0)update(1,1,q+1,last[i],q+1,i);
    }

    dfs(1,1,q+1);

    return 0;
}
