#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const int maxc=3007;

int n,q,type,pt,d;
int a[MAXN],last[maxc];
int cnt[maxc],temp[maxc],power;

const long long modd=1000000007;
const int mod=1000000007;

long long ans;

pair<int,int> v[maxc*maxc];
vector<int> tree[4*MAXN];
int gccc[maxc+7][maxc+7];

int gcd(int a,int b){
    if(b==0)return a;
    return gcd(b,a%b);
}

void add(int x){
    for(int i=1;i<=maxc;i++){
        temp[i]=0;
    }
    for(int i=1;i<=maxc;i++){
        d=gccc[i][x];
        temp[d]+=cnt[i];
        temp[d]%=mod;
    }
    for(int i=1;i<=maxc;i++){
        pt++;v[pt]={i,cnt[i]};

        cnt[i]+=temp[i];
        if(i==x)cnt[i]++;
        cnt[i]%=mod;
    }
}

void calc(){
    ans=0;
    for(int i=1;i<=maxc;i++){
        ans+=(long long) cnt[i]*i;
        ans%=modd;
    }
}

void undoadd(){
    for(int i=pt;i>=pt-maxc+1;i--){
        cnt[v[i].first]=v[i].second;
    }
    pt-=maxc;
}

void update(int v,int l,int r,int ll,int rr,int val){
    if(ll>rr)return;
    if(l==ll and r==rr){
        tree[v].push_back(val);
    }else{
        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,val);
    }
}

void dfs(int v,int l,int r){
    for(int i=0;i<tree[v].size();i++)add(tree[v][i]);

    if(l==r){
        calc();
        cout<<ans<<"\n";
    }else{
        int tt=(l+r)/2;
        dfs(2*v,l,tt);
        dfs(2*v+1,tt+1,r);
    }

    for(int i=0;i<tree[v].size();i++)undoadd();
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>a[i];
        last[a[i]]=1;
    }

    for(int i=1;i<=maxc;i++){
        for(int f=1;f<=maxc;f++){
            gccc[i][f]=gcd(i,f);
        }
    }

    for(int i=2;i<=q+1;i++){
        cin>>type>>a[0];
        if(type==1)last[a[0]]=i;
        else {update(1,1,q+1,last[a[0]],i-1,a[0]); last[a[0]]=0;}
    }

    for(int i=1;i<=maxc;i++){
        if(last[i]!=0)update(1,1,q+1,last[i],q+1,i);
    }

    dfs(1,1,q+1);

    return 0;
}
