#include<bits/stdc++.h>
#define lli int
#define endl "\n"
using namespace std;
const lli MAXN=1000006;
lli a[MAXN], N, Q, vh1, vh2, vh3, lazy[4*MAXN];
deque<lli> tree[4*MAXN];
void merged(lli ind, lli ind1, lli ind2){
    tree[ind].clear();
    if(tree[ind1].size()>tree[ind2].size())swap(ind1, ind2);
    for(lli i=0; i<tree[ind1].size(); i++){
        tree[ind].push_back(tree[ind1][i]+tree[ind2][i]);
    }
    for(lli i=tree[ind1].size(); i<tree[ind2].size(); i++){
        tree[ind].push_back(tree[ind2][i]);
    }
    return;
}
void build(lli ind, lli l, lli r){
    lazy[ind]=0;
    if(l==r){
        while(a[l]!=0){
            tree[ind].push_back(a[l]%10);
            a[l]/=10;
        }
        return;
    }
    lli mid=(l+r)/2;
    build(2*ind, l, mid);
    build(2*ind+1, mid+1, r);
    merged(ind, 2*ind, 2*ind+1);
    return;
}
void rotate(lli ind, lli br){
    for(lli i=0; i<br; i++){
        lli q=tree[ind].front();
        tree[ind].pop_front();
        tree[ind].push_back(q);
    }
    return;
}
void push_lazy(lli ind, lli l, lli r){
    if(l==r){
        rotate(ind, lazy[ind]);
        lazy[ind]=0;
        return;
    }
    rotate(ind, lazy[ind]);
    lazy[2*ind]+=lazy[ind];
    lazy[2*ind+1]+=lazy[ind];
    lazy[ind]=0;
    return;
}
void update(lli ind, lli l, lli r, lli ql, lli qr){
    if(l>qr or r<ql)return;
    if(ql<=l and r<=qr){
        lazy[ind]++;
        push_lazy(ind, l, r);
        return;
    }
    push_lazy(ind, l, r);
    lli mid=(l+r)/2;
    update(2*ind, l, mid, ql, qr);
    update(2*ind+1, mid+1, r, ql, qr);
    merged(ind, 2*ind, 2*ind+1);
    return;
}
lli answer(lli ind){
    lli st=1, ans=0;
    for(lli i=0; i<tree[ind].size(); i++){
        ans+=tree[ind][i]*st;
        st*=10;
    }
    return ans;
}
lli query(lli ind, lli l, lli r, lli ql, lli qr){
    if(l>qr or r<ql)return 0;
    push_lazy(ind, l, r);
    if(ql<=l and r<=qr)return answer(ind);
    lli mid=(l+r)/2;
    return query(2*ind, l, mid, ql, qr)+query(2*ind+1, mid+1, r, ql, qr);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>Q;
    for(lli i=1; i<=N; i++){
        cin>>a[i];
    }
    build(1, 1, N);
    for(lli i=0; i<Q; i++){
        cin>>vh1>>vh2>>vh3;
        if(vh1==1){
            update(1, 1, N, vh2, vh3);
        }else{
            cout<<query(1, 1, N, vh2, vh3)<<endl;
        }
    }
    return 0;
}