#include <iostream>
using namespace std;
int magnitude(int x) {
    if (x == 0) {
        return 0;
    }
    return magnitude(x / 10) + 1;
}
int force(int x, int y) {
    if (y == 0) {
        return 1;
    }
    return force(x, y - 1) * x;
}
int a[1000000];
int sum(int l, int r) {
    if (l == r) {
        return a[l];
    }
    return a[l] + sum(l + 1, r);
}
void update(int l, int r) {
    a[l] = a[l] / 10 + (a[l] % 10) * force(10, magnitude(a[l]) - 1);
    if (l != r) {
        update(l + 1, r);
    }
}
int main () {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        int q, l, r;
        cin >> q >> l >> r;
        l--;
        r--;
        if (q == 1) {
            update(l, r);
        }
        if (q == 2) {
            cout << sum(l, r) << endl;
        }
    }
    return 0;
}
