#include <iostream>
using namespace std;
pair<int, int> updates[50000];
int counter = 0;
int magnitude(int x) {
    if (x == 0) {
        return 0;
    }
    return magnitude(x / 10) + 1;
}
int force(int x, int y) {
    if (y == 0) {
        return 1;
    }
    return force(x, y - 1) * x;
}
int a[1000000];
int sum(int l, int r) {
    if (l > r) {
        return 0;
    }
    int curr = a[l], t = 0;
    for (int i = 0; i < counter; i++) {
        if (l >= updates[i].first && l <= updates[i].second) {
            curr = curr / 10 + (curr % 10) * force(10, magnitude(curr) - 1);
        }
    }
//    cout << "\naaa\n" << curr << "\naaa\n";
    return curr + sum(l + 1, r);
}
void update(int l, int r) {
    a[l] = a[l] / 10 + (a[l] % 10) * force(10, magnitude(a[l]) - 1);
    if (l != r) {
        update(l + 1, r);
    }
}
int main () {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        int q, l, r;
        cin >> q >> l >> r;
        l--;
        r--;
        if (q == 1) {
            updates[counter].first = l;
            updates[counter].second = r;
            counter++;
        }
        if (q == 2) {
            cout << sum(l, r) << endl;
        }
    }
    return 0;
}
