#include<iostream>
#define endl '\n'
using namespace std;
long long a[1000005],tree[7][7][4000005],lazy[4000005],dig[1000005],t[10];
long long st[10]={1,10,100,1000,10000,100000,1000000};
void finddig(long long a)
{
    long long br=0,p=a;
    while(p>0)
    {
        br++;p/=10;
    }
    dig[a]=br;
}
void build(long long node,long long l,long long r)
{
    if(l==r)
    {
        long long p=a[l];
        for(long long i=1;i<=6;i++)
        {
            tree[dig[a[l]]][i][node]=p%10;
            p/=10;
        }
        return;
    }
    long long mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    for(long long i=1;i<=6;i++)
    {
        for(long long j=1;j<=6;j++)
          tree[i][j][node]=tree[i][j][2*node]+tree[i][j][2*node+1];
    }
}
void update(long long node,long long l,long long r,long long le,long long ri)
{
    if(l>=le && r<=ri)
        lazy[node]+=1;

    if(lazy[node])
    {
        for(int i=2;i<=6;i++)
        {
            long long g=lazy[node]%i,pos;
            for(int p=1;p<=i;p++)
            {
                pos=(p-g+i)%i;if(pos==0) pos=i;
                t[pos]=tree[i][p][node];
            }
            for(int p=1;p<=i;p++)
            {
                tree[i][p][node]=t[p];
            }
        }

        if(l!=r)
        {
            lazy[2*node]+=lazy[node];
            lazy[2*node+1]+=lazy[node];
        }
        lazy[node]=0;
    }
    if((l>=le && r<=ri) || (l>ri || r<le)) return;

    long long mid=(l+r)/2;

    update(2*node,l,mid,le,ri);
    update(2*node+1,mid+1,r,le,ri);

    for(long long i=1;i<=6;i++)
    {
        for(long long j=1;j<=6;j++)
          tree[i][j][node]=tree[i][j][2*node]+tree[i][j][2*node+1];
    }
}
long long query(long long node,long long l,long long r,long long le,long long ri)
{
    if(lazy[node])
    {
       for(int i=2;i<=6;i++)
        {
            long long g=lazy[node]%i,pos;
            for(int p=1;p<=i;p++)
            {
                pos=(p-g+i)%i;if(pos==0) pos=i;
                t[pos]=tree[i][p][node];
            }
            for(int p=1;p<=i;p++)
            {
                tree[i][p][node]=t[p];
            }
        }
        if(l!=r)
        {
            lazy[2*node]+=lazy[node];
            lazy[2*node+1]+=lazy[node];
        }
        lazy[node]=0;
    }
    if((l>ri || r<le)) return 0;
    if(l>=le && r<=ri)
    {
        long long s=0;
        for(int i=1;i<=6;i++)
        {
            for(int j=1;j<=i;j++)
                s+=tree[i][j][node]*st[j-1];
        }
        return s;
    }
    long long mid=(l+r)/2,r1,r2;

    r1=query(2*node,l,mid,le,ri);
    r2=query(2*node+1,mid+1,r,le,ri);

     for(long long i=1;i<=6;i++)
    {
        for(long long j=1;j<=6;j++)
          tree[i][j][node]=tree[i][j][2*node]+tree[i][j][2*node+1];
    }

    return r1+r2;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,q,z,l,r;
    cin>>n>>q;

    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        finddig(a[i]);
    }
    build(1,1,n);

    for(long long i=1;i<=q;i++)
    {
        cin>>z>>l>>r;
        if(z==1)
        {
            update(1,1,n,l,r);
           // cout<<query(1,1,n,l,r)<<endl;
        }
        if(z==2)
        {
            cout<<query(1,1,n,l,r)<<endl;
        }
    }

}
/*
3 5
15 35 11
2 1 2
1 2 3
2 1 3
1 1 2
2 2 3

5 3
32 1235 111 1 13
2 1 3
1 2 5
2 1 3

7 4
10001 678 3 564 743 234 111
2 1 2
1 3 6
1 2 5
2 1 7
*/

